//==============================================================
// 摜\C
//--------------------------------------------------------------
// 
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <time.h>
#include <setjmp.h>												/* setjmp() / longjmp() */
#include <jpeglib.h>
#include <png.h>
#include <gif_lib.h>
#include <pspgu.h>
#include <pspdisplay.h>
#include <psprtc.h>
#include <zlib.h>												// compress()
#include "fvDraw.h"
#include "fvView.h"
#include "psp2chImageReader.h"
#include "charConv.h"
#include "psp2chError.h"
#include "dialog.h"
#include "fileList.h"

#define LIMIT_WIDTH			(1024)								// 摜̍ő\WIDTH
#define PNG_BYTES_TO_CHECK	(8)									// PNG̐擪wb_TCY
#define BUF_WIDTH			(512)								// eNX`[XőTCY
#define BUF_WIDTH_BIT		(0x1FF)								// eNX`[XőTCYɑrbg}XN
#define BUF_HEIGHT			(512)								// eNX`[YőTCY
#define TEX_HEIGHT			(256)								// eNX`[YTCY
#define TEX_HEIGHT_BIT		(0x0FF)								// eNX`[YTCYɑrbg}XN
#define THUMB_LIST_STEP		(60)								// TlCXg̊Ԋu

//----- \ ----

typedef struct {
	Color			**tex;										// X x Y eNX`ziNULL:C[Wj
	unsigned int	count;										// eNX`̑
	unsigned int	countX;										// eNX`X
	unsigned int	width;										// ŜłXTCY
	unsigned int	height;										// ŜłYTCY
	unsigned int	widthAlign;									// XŏIeNX`̃TCY
} strTex;

typedef struct {												// 摜\̏Ǘ
	int				width2;
	int				height2;
	strTex			orgTex1;									// 摜eNX`P
	strTex			orgTex2;									// 摜eNX`QiAj[VGIFpj
	strTex			*orgTex;									// 摜eNX`i؂ւpj
	strTex			sdTex;										// 1/nꂽeNX`
	int				sdThumb;									// sdTex ̏kni1, 2, 3 cj
} strPicView;

typedef struct tex {
	int		w;
	int		h;
	int		tb;
} TEX;

typedef struct {												// ʕ\Ɋւf[^
	double			startX;										// 摜̕\ʒu
	double			startY;										// 摜̕\ʒu
	double			range;										// 摜Ŝ̏k
	int				drawFlag;									// vi0:Ȃj
	int				viewFlag;									// ʂXV邩i0:Ȃj
	int				sdDrawFlag;									// keNX`XV邩i0:Ȃj
	int				reset;										// \ʒui0:Noj
	int				menu;										// KCh\[h
	int				filter;										// 摜ɃX[WOsi0:j
	int				roll;										// 摜̉]w
	int				pauseFlag;									// Aj[V̈ꎞ~i0:Noj
	int				infoFlag;									// ̕\i0:Noj
	int				sizeMode;									// ʃTCY[hi-1:ʃtBbg, 0: , 1: , 2:j
	int				sizeModeSwap;								// 摜TCY̑JڂύX邩i0:Noj
	int				cFlag;										// +
	DrawImg			*thumb;										// TlC摜
	unsigned int	viewTime;									// Ỏʍ掞
	float			nowX;										// ʃXCȟ݈ʒu
	int				targetX;									// ʃXCh̖ڕWʒu
	int				nowFPos;									// ʃXCḧړt@C
	int				backFPos;									// wi摜擾ꂽt@Cʒui-1:擾ĂȂj
	int				backImgDis;									// ʃXCh̎擾wi摜͗Li0:Lj
	int				FPos;										// wi摜擾̃t@Cʒuʒmp
} strVInfo;

struct Vertex {
	unsigned	short u, v;
	unsigned	char color;
	short		x, y, z;
};

struct strGif {													// GIF̊epbgL^C[Wobt@
	int				transparent;								// ߐF
	int				delaytime;									// t[Ԓx
	int				top, left, height, width;					// ̈
	int				ColorCount;
	int				ColorMap;
	GifRowType		ImgBuf;										// pbgC[W
	int				*Colors;									// pbge[u
	struct strGif	*next;										// ̃obt@ւ̃|C^ (NULLF͖)
};

volatile struct {
	char			*path;										// 摜̂tH_pX
	char			info[512];									// 摜vpeB
	int				mode;										// 
	int				ret;										// fR[hI
	int				nextFlag;									// Aj[VGIFŎ̉摜̃fR[hJni0:ҋ@j
	unsigned int	delaytime;									// Aj[VGIFŎ̉摜ɐ؂ւ܂ł̎ԁi[ms]j
	int				cancelFlag;									// fR[hLZvi1:LZj
	strPicView		pv;											// 摜f[^
	int				anime;										// Aj[V邩i0:Ȃj
	int				aniPage;									// Aj[V̓WJeNX`wp
	int				drawEnd;									// Pڂ̉摜fR[hIi0:Noj
	int				sdFlag;										// keNX`𐶐邩iGIFAj[Vł͏kȂji0:Ȃj
} gVData;														// Tu^XN烁C^XNփf[^n󂯎M

//----- ϐ -----

extern S_2CH	s2ch;											// fvTool.c
int		gLoadId;												// t@C[hXbhID

//----- vg^Cv -----

METHODDEF(void) my_error_exit(j_common_ptr cinfo);

int makedir (char *newdir);										// unzip/miniunz.c


//==============================================================
// G[
//--------------------------------------------------------------

//----- jpegG[[` -----

METHODDEF(void) my_error_exit(j_common_ptr cinfo)
{
	char buffer[JMSG_LENGTH_MAX];

	my_error_ptr err = (my_error_ptr)cinfo->err;
	(*cinfo->err->format_message) (cinfo, buffer);
	//psp2chErrorDialog(0, "%s", buffer);
	longjmp( err->setjmp_buffer, 1 );
}

//----- PNGG[[` -----

static void myPngError(png_structp png_ptr,png_const_charp message)
{
	//psp2chErrorDialog(0, "%s", message);
	longjmp( png_ptr->jmpbuf, 1 );
}


//==============================================================
// eNX`\
//--------------------------------------------------------------
// filter 0:X[WO
//--------------------------------------------------------------

static int NextPower2(int x)
{
	int		n;

	n = 1;
	while (n < x && n) n <<= 1;
	return n;
}

#define SLICE_SIZE 64
static void blt(strTex *src, int x, int y, double range, int filter)
{
	int				xx1, xx2, yy1, yy2;
	struct Vertex	*vertices;
	unsigned int	x1, y1, sy, step, count, width, width2;

	//----- ݒ -----

	sceKernelDcacheWritebackInvalidateAll();					// LbVNA
	sceGuDisable(GU_DEPTH_TEST);
	sceGuTexMode( GU_PSM_8888, 0, 0, GU_FALSE );
	sceGuTexFunc( GU_TFX_REPLACE, GU_TCC_RGBA );
	sceGuTexWrap( GU_CLAMP, GU_CLAMP );
	if (range == 1.0 || filter) {
		sceGuTexFilter( GU_NEAREST, GU_NEAREST );				// hbg
	} else {
		sceGuTexFilter( GU_LINEAR, GU_LINEAR );					// X[WO
	}

	//----- 揈 -----

	count = 0;
	sy = 0;
	if (y < 0) {												// JnʒũV[gJbg
		count = (-y) * range / TEX_HEIGHT;
		count *= src->countX;
		sy = -y * range;
		sy &= ~TEX_HEIGHT_BIT;
		y += sy / range;
	}
	for (y1 = 0; y1+TEX_HEIGHT <= src->height - sy; y1 += TEX_HEIGHT) {						// YTCYTEX_HEIGHT𒴂Ă
		yy1 = y + y1 / range;
		yy2 = y + (y1 + TEX_HEIGHT) / range;
		for (x1 = 0; x1+BUF_WIDTH <= src->width; x1 += BUF_WIDTH) {							// XTCY512𒴂Ă
			sceGuTexImage( 0, BUF_WIDTH, TEX_HEIGHT, BUF_WIDTH, src->tex[count++] );
			for (step = 0; step < BUF_WIDTH; step += SLICE_SIZE) {							// eNX`̉64hbgPʂō
				xx1 = x + (x1 + step) / range;
				xx2 = x + (x1 + step + SLICE_SIZE) / range;
				if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
					vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
					vertices[0].u = step;
					vertices[0].v = 0;
					vertices[0].x = xx1;
					vertices[0].y = yy1;
					vertices[1].u = step + SLICE_SIZE;
					vertices[1].v = TEX_HEIGHT;
					vertices[1].x = xx2;
					vertices[1].y = yy2;
					sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
				}
			}
		}
		width = src->width - x1;																			// ܂hbg
		sceGuTexImage( 0, NextPower2(src->widthAlign), TEX_HEIGHT, src->widthAlign, src->tex[count++] );	// eNX`̉E܂hbg
		for (step = 0; step < width; step += SLICE_SIZE) {													// eNX`̉64hbgPʂō
			if (width-step < SLICE_SIZE) {
				width2 = width-step;
			} else {
				width2 = SLICE_SIZE;
			}
			xx1 = x + (x1 + step) / range;
			xx2 = x + (x1 + step + width2) / range;
			if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
				vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
				vertices[0].u = step;
				vertices[0].v = 0;
				vertices[0].x = xx1;
				vertices[0].y = yy1;
				vertices[1].u = step + width2;
				vertices[1].v = TEX_HEIGHT;
				vertices[1].x = xx2;
				vertices[1].y = yy2;
				sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
			}
		}
		if (yy1 >= SCREEN_HEIGHT) break;						// ʔ͈͊OɂȂ̂ŏ𒆒f
	}
	yy1 = y + y1 / range;
	yy2 = y + (src->height - sy) / range;
	if (yy1 < SCREEN_HEIGHT) {
		for (x1 = 0; x1+BUF_WIDTH <= src->width; x1 += BUF_WIDTH) {								// XTCY512𒴂Ă
			sceGuTexImage( 0, BUF_WIDTH, TEX_HEIGHT, BUF_WIDTH, src->tex[count++] );
			for (step = 0; step < BUF_WIDTH; step += SLICE_SIZE) {								// eNX`̉64hbgPʂō
				xx1 = x + (x1 + step) / range;
				xx2 = x + (x1 + step + SLICE_SIZE) / range;
				if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
					vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
					vertices[0].u = step;
					vertices[0].v = 0;
					vertices[0].x = xx1;
					vertices[0].y = yy1;
					vertices[1].u = step + SLICE_SIZE;
					vertices[1].v = src->height & TEX_HEIGHT_BIT;
					vertices[1].x = xx2;
					vertices[1].y = yy2;
					sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
				}
			}
		}
		width = src->width - x1;																			// ܂hbg
		sceGuTexImage( 0, NextPower2(src->widthAlign), TEX_HEIGHT, src->widthAlign, src->tex[count] );		// eNX`̉E܂hbg
		for (step = 0; step < width; step += SLICE_SIZE) {													// eNX`̉64hbgPʂō
			if (width-step < SLICE_SIZE) {
				width2 = width - step;
			} else {
				width2 = SLICE_SIZE;
			}
			xx1 = x + (x1 + step) / range;
			xx2 = x + (x1 + step + width2) / range;
			if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
				vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
				vertices[0].u = step;
				vertices[0].v = 0;
				vertices[0].x = xx1;
				vertices[0].y = yy1;
				vertices[1].u = step + width2;
				vertices[1].v = src->height & TEX_HEIGHT_BIT;
				vertices[1].x = xx2;
				vertices[1].y = yy2;
				sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
			}
		}
	}
}


//==============================================================
// eNX`\i270]j
//--------------------------------------------------------------

static void blt_270(strTex *src, int x, int y, double range, int filter)
{
	int				xx1, xx2, yy1, yy2;
	struct Vertex	*vertices;
	unsigned int	x1, y1, sy, step, count, width, width2;

	//----- ݒ -----

	sceKernelDcacheWritebackInvalidateAll();					// LbVNA
	sceGuDisable(GU_DEPTH_TEST);
	sceGuTexMode( GU_PSM_8888, 0, 0, GU_FALSE );
	sceGuTexFunc( GU_TFX_REPLACE, GU_TCC_RGBA );
	sceGuTexWrap( GU_CLAMP, GU_CLAMP );
	if (range == 1.0 || filter) {
		sceGuTexFilter( GU_NEAREST, GU_NEAREST );				// hbg
	} else {
		sceGuTexFilter( GU_LINEAR, GU_LINEAR );					// X[WO
	}

	//----- 揈 -----

	count = 0;
	sy = 0;
	if (y < 0) {												// JnʒũV[gJbg
		count = (-y) * range / TEX_HEIGHT;
		count *= src->countX;
		sy = -y * range;
		sy &= ~TEX_HEIGHT_BIT;
		y += sy / range;
	}
	for (y1 = 0; y1+TEX_HEIGHT <= src->height - sy; y1 += TEX_HEIGHT) {						// YTCYTEX_HEIGHT𒴂Ă
		yy1 = y + y1 / range;
		yy2 = y + (y1 + TEX_HEIGHT) / range;
		for (x1 = 0; x1+BUF_WIDTH <= src->width; x1 += BUF_WIDTH) {							// XTCY512𒴂Ă
			sceGuTexImage( 0, BUF_WIDTH, TEX_HEIGHT, BUF_WIDTH, src->tex[count++] );
			for (step = 0; step < BUF_WIDTH; step += SLICE_SIZE) {							// eNX`̉64hbgPʂō
				xx1 = x + (x1 + step) / range;
				xx2 = x + (x1 + step + SLICE_SIZE) / range;
				if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
					vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
					vertices[0].u = step;
					vertices[0].v = 0;
					vertices[0].x = xx1;
					vertices[0].y = yy1;
					vertices[1].u = step + SLICE_SIZE;
					vertices[1].v = TEX_HEIGHT;
					vertices[1].x = xx2;
					vertices[1].y = yy2;
					sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
				}
			}
		}
		width = src->width - x1;																			// ܂hbg
		sceGuTexImage( 0, NextPower2(src->widthAlign), TEX_HEIGHT, src->widthAlign, src->tex[count++] );	// eNX`̉E܂hbg
		for (step = 0; step < width; step += SLICE_SIZE) {													// eNX`̉64hbgPʂō
			if (width-step < SLICE_SIZE) {
				width2 = width-step;
			} else {
				width2 = SLICE_SIZE;
			}
			xx1 = x + (x1 + step) / range;
			xx2 = x + (x1 + step + width2) / range;
			if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
				vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
				vertices[0].u = step;
				vertices[0].v = 0;
				vertices[0].x = xx1;
				vertices[0].y = yy1;
				vertices[1].u = step + width2;
				vertices[1].v = TEX_HEIGHT;
				vertices[1].x = xx2;
				vertices[1].y = yy2;
				sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
			}
		}
		if (yy1 >= SCREEN_HEIGHT) break;						// ʔ͈͊OɂȂ̂ŏ𒆒f
	}
	yy1 = y + y1 / range;
	yy2 = y + (src->height - sy) / range;
	if (yy1 < SCREEN_HEIGHT) {
		for (x1 = 0; x1+BUF_WIDTH <= src->width; x1 += BUF_WIDTH) {								// XTCY512𒴂Ă
			sceGuTexImage( 0, BUF_WIDTH, TEX_HEIGHT, BUF_WIDTH, src->tex[count++] );
			for (step = 0; step < BUF_WIDTH; step += SLICE_SIZE) {								// eNX`̉64hbgPʂō
				xx1 = x + (x1 + step) / range;
				xx2 = x + (x1 + step + SLICE_SIZE) / range;
				if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
					vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
					vertices[0].u = step;
					vertices[0].v = 0;
					vertices[0].x = xx1;
					vertices[0].y = yy1;
					vertices[1].u = step + SLICE_SIZE;
					vertices[1].v = src->height & TEX_HEIGHT_BIT;
					vertices[1].x = xx2;
					vertices[1].y = yy2;
					sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
				}
			}
		}
		width = src->width - x1;																			// ܂hbg
		sceGuTexImage( 0, NextPower2(src->widthAlign), TEX_HEIGHT, src->widthAlign, src->tex[count] );		// eNX`̉E܂hbg
		for (step = 0; step < width; step += SLICE_SIZE) {													// eNX`̉64hbgPʂō
			if (width-step < SLICE_SIZE) {
				width2 = width - step;
			} else {
				width2 = SLICE_SIZE;
			}
			xx1 = x + (x1 + step) / range;
			xx2 = x + (x1 + step + width2) / range;
			if (xx1<SCREEN_WIDTH && xx2>0 && yy1<SCREEN_HEIGHT && yy2>0) {
				vertices = (struct Vertex *)sceGuGetMemory( 2 * sizeof(struct Vertex) );
				vertices[0].u = step;
				vertices[0].v = 0;
				vertices[0].x = xx1;
				vertices[0].y = yy1;
				vertices[1].u = step + width2;
				vertices[1].v = src->height & TEX_HEIGHT_BIT;
				vertices[1].x = xx2;
				vertices[1].y = yy2;
				sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_COLOR_4444 | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
			}
		}
	}
}


//==============================================================
// TlC̐
//--------------------------------------------------------------
// WJꂽ摜C[WTHUMBXSIZExTHUMBYSIZE͈͓̔Ɏ܂悤ɏkA
// TlCtH_֕ۑB
// TlCɎ擾Ăꍇł摜̃^CX^vɕω
// ꍇ͍ĐsB
// TlCt@Cɂ͉摜ɊւꏏɋL^܂B
//--------------------------------------------------------------

static void makeThumb(strPicView *pv, FileData *FData, char *thumbPath)
{
	SceUID			fd;
	DrawImg			*pic;
	unsigned short	*buf;
	char			*p, path[1024];
	int				width2, height2, bufsize;
	double			range;

	if (FData->thumb && (FData->thumbTime.year==FData->mtime.year &&
	                     FData->thumbTime.month==FData->mtime.month &&
	                     FData->thumbTime.day==FData->mtime.day &&
	                     FData->thumbTime.hour==FData->mtime.hour &&
	                     FData->thumbTime.minute==FData->mtime.minute &&
	                     FData->thumbTime.second==FData->mtime.second) ) {
		return;													// TlCƉ摜̃^CX^vȂ珈Ȃ
	}
	range = (double)pv->orgTex->width / (double)THUMBXSIZE;		// ɍ킹ꍇ̔{
	if (pv->orgTex->height/range > THUMBYSIZE) {				// cTHUMBYSIZE𒴂ȂC
		range = (double)pv->orgTex->height / (double)THUMBYSIZE;
		if (range < 1.0f) range = 1.0f;							// TlCTCYȉ̉摜͌
	}
	width2 = pv->orgTex->width / range;
	height2 = pv->orgTex->height / range;
	if (width2 == 0) width2 = 1;
	if (height2 == 0) height2 = 1;
	pic = DrawImgCreate( width2, height2 );
	if (pic) {
		if (FData->thumb) DrawImgFree( FData->thumb );
		guStart();
		sceGuClearColor( s2ch.BakCor );
		sceGuClear( GU_COLOR_BUFFER_BIT );
		blt( pv->orgTex, 0, 0, range, 0 );						// TlC
		sceGuFinish();
		sceGuSync( 0, 0 );
		BoxCopy2( pic, 0, 0 );									// TlC荞
		FData->thumb = pic;
		FData->xSize = pv->orgTex->width;
		FData->ySize = pv->orgTex->height;
		FData->thumbTime.year = FData->mtime.year;
		FData->thumbTime.month = FData->mtime.month;
		FData->thumbTime.day = FData->mtime.day;
		FData->thumbTime.hour = FData->mtime.hour;
		FData->thumbTime.minute = FData->mtime.minute;
		FData->thumbTime.second = FData->mtime.second;			// TlCt@CɃZbg
		bufsize = 32 + malloc_usable_size( pic->data );
		buf = (unsigned short*) memalign( 16, bufsize * 1.2 );
		if (buf) {
			buf[0] = THUMBID | 0x0100;
			buf[1] = width2;									// TlCXTCY
			buf[2] = height2;									// TlCYTCY
			buf[3] = FData->mtime.year;							// 摜̃^CX^v
			buf[4] = FData->mtime.month;
			buf[5] = FData->mtime.day;
			buf[6] = FData->mtime.hour;
			buf[7] = FData->mtime.minute;
			buf[8] = FData->mtime.second;
			buf[9] = pv->orgTex->width;							// 摜̃TCY
			buf[10] = pv->orgTex->height;
			buf[11] = 0;
			buf[12] = 0;
			buf[13] = 0;
			buf[14] = 0;
			buf[15] = 0;
			bufsize -= 32;
			compress( (Bytef*)&buf[16], (uLongf*)&bufsize, (Bytef*)pic->data, malloc_usable_size(pic->data) );
			bufsize += 32;
			p = strrchr( thumbPath, '/' );
			if (p) {
				strncpy( path, thumbPath, p - thumbPath );
				path[p - thumbPath] = '\0';
				if (makedir(path)) {							// wtH_̐ɐ
					fd = sceIoOpen( thumbPath, PSP_O_WRONLY | PSP_O_CREAT, FILE_PARMISSION );
					if (fd >= 0) {
						sceIoWrite( fd, buf, bufsize );
						sceIoClose( fd );
					}
				}
			}
			free( buf );
		}
	}
}


//==============================================================
// eNX`zm
//--------------------------------------------------------------
// w肳ꂽ傫̉摜[߂eNX`zmۂB
// 
//--------------------------------------------------------------

static int getTexMem(strTex *tex, unsigned int width, unsigned int height)
{
	int		x, y, ret, count;
	Color	*imgbuf;

	tex->width = width;
	tex->height = height;
	width++;
	height++;
	tex->count = 0;
	count = ((width / BUF_WIDTH) + 1) * ((height / TEX_HEIGHT) + 1);
	tex->tex = memalign( 16, sizeof(Color*) * count );			// eNX`̐擪|C^z
	if (!tex->tex) {
		return MEM_ERR;
	}
	count = 0;
	ret = 0;
	for (y = height; y > TEX_HEIGHT; y -= TEX_HEIGHT) {			// YTCYeNX`TCY𒴂Ă
		for (x = width; x > BUF_WIDTH; x -= BUF_WIDTH) {
			imgbuf = calloc( BUF_WIDTH * TEX_HEIGHT, sizeof(Color) );
			if (!imgbuf) {
				ret = MEM_ERR;
				break;
			}
			tex->tex[count++] = imgbuf;
		}
		if (ret == MEM_ERR) break;
		x = (x + 15) & 0xFFFFFFF0;
		imgbuf = calloc( x * TEX_HEIGHT, sizeof(Color) );
		if (!imgbuf) {
			ret = MEM_ERR;
			break;
		}
		tex->tex[count++] = imgbuf;
	}
	if (ret != MEM_ERR) {										// YTCYeNX`TCYȉ
		tex->countX = 1;
		for (x = width; x > BUF_WIDTH; x -= BUF_WIDTH) {
			imgbuf = calloc( BUF_WIDTH * y, sizeof(Color) );
			if (!imgbuf) {
				ret = MEM_ERR;
				break;
			}
			tex->tex[count++] = imgbuf;
			tex->countX++;
		}
		if (ret != MEM_ERR) {
			tex->widthAlign = (x + 15) & 0xFFFFFFF0;			// I[eNX`XTCY
			imgbuf = calloc( tex->widthAlign * y, sizeof(Color) );
			if (!imgbuf) {
				ret = MEM_ERR;
			} else {
				tex->tex[count++] = imgbuf;
			}
		}
	}
	tex->count = count;

	if (ret == MEM_ERR) {										// r[Ɋmۂ
		unsigned int	i;
		if (tex->tex) {											// eNX`̉
			for (i = 0; i < tex->count; i++) {
				free( tex->tex[i] );
			}
			free( tex->tex );
			tex->tex = NULL;
		}
	}
	return ret;
}


//==============================================================
// eNX`z
//--------------------------------------------------------------

static void freeSdTex(strPicView *pv)
{
	unsigned int	i;

	if (!pv->sdTex.tex) return;

	for (i = 0; i < pv->sdTex.count; i++) {
		free( pv->sdTex.tex[i] );
	}
	free( pv->sdTex.tex );
	pv->sdTex.tex = NULL;
	pv->sdThumb = 0;
}

static void freeOrgTex(strTex *orgTex)
{
	unsigned int	i;

	if (!orgTex->tex) return;

	for (i = 0; i < orgTex->count; i++) {
		free( orgTex->tex[i] );
	}
	free( orgTex->tex );
	orgTex->tex = NULL;
}

static void freeTexMem(strPicView *pv)
{
	freeSdTex( pv );											// keNX`̉
	freeOrgTex( &pv->orgTex1 );									// eNX`̉
	freeOrgTex( &pv->orgTex2 );									// eNX`̉
	pv->orgTex = &pv->orgTex1;
}


//==============================================================
// ̉摜t@CT
//--------------------------------------------------------------
// t@CXg̓[vĂƌȂĂB
//--------------------------------------------------------------

static int nextImage(DirList *DList, int pos)
{
	int		i;

	pos++;
	if (pos >= DList->count) {
		pos -= DList->count;
	}
	for (i = 0; i < DList->count; i++) {
		if (checkExt(DList->file[pos].name) < EXT_TYPE_IMAGE) {
			break;
		}
		pos++;
		if (pos >= DList->count) {
			pos -= DList->count;
		}
	}
	return pos;
}


//==============================================================
// Ỏ摜t@CT
//--------------------------------------------------------------
// t@CXg̓[vĂƌȂĂB
//--------------------------------------------------------------

static int backImage(DirList *DList, int pos)
{
	int		i;

	pos--;
	if (pos < 0) {
		pos += DList->count;
	}
	for (i = 0; i < DList->count; i++) {
		if (checkExt(DList->file[pos].name) < EXT_TYPE_IMAGE) {
			break;
		}
		pos--;
		if (pos < 0) {
			pos += DList->count;
		}
	}
	return pos;
}


//==============================================================
// 摜wiɃTlCg\
//--------------------------------------------------------------
// ʃXCh̊֌WA\TlC͕K݃fR[h
// ƒ̃t@C̃mƂ͌ȂB
//--------------------------------------------------------------

//===== 摜 =====

static void picDraw(strPicView *pv, strVInfo *vinfo, DirList *DList, int FPos, int x)
{
	if (pv!=NULL && FPos==DList->pos) {
		if (pv->sdTex.tex) {									// keNX`݂Ȃ
			blt( &pv->sdTex, (SCREEN_WIDTH/2) - (pv->width2/2) - vinfo->startX + x,
			                 (SCREEN_HEIGHT/2) - (pv->height2/2) - vinfo->startY,
			     vinfo->range / pv->sdThumb, vinfo->filter );
		} else {												// eNX`
			blt( pv->orgTex, (SCREEN_WIDTH/2) - (pv->width2/2) - vinfo->startX + x,
			                 (SCREEN_HEIGHT/2) - (pv->height2/2) - vinfo->startY,
			     vinfo->range, vinfo->filter );
		}
	}
}

//===== wi =====

static void backDraw(strPicView *pv, strVInfo *vinfo, DirList *DList, int FPos, int x)
{
	int			x1, x2, x3, y1, flag;
	strTex		bakTex;
	double		range;
	DrawImg		thumbImg;
	FileData	*FData;

	//----- wi摜 -----

	if (!vinfo->backImgDis) {
		if (x < 0) {											// XCh
			if (FPos == vinfo->backFPos) {						// wi摜擾Ăt@Cʒu
				x1 = -x;
				x2 = SCREEN_WIDTH + x;
				x3 = 0;
				sceGuCopyImage(GU_PSM_8888, x1, 0, x2, SCREEN_HEIGHT, gScrBuf1->width, gScrBuf1->data, x3, 0, PSP_LINE_SIZE, getVramDrawBuffer());
				return;
			}
		} else {												// XCh
			if (FPos == vinfo->backFPos) {						// wi摜擾Ăt@Cʒu
				x1 = 0;
				x2 = SCREEN_WIDTH - x;
				x3 = x;
				sceGuCopyImage(GU_PSM_8888, x1, 0, x2, SCREEN_HEIGHT, gScrBuf1->width, gScrBuf1->data, x3, 0, PSP_LINE_SIZE, getVramDrawBuffer());
				return;
			}
		}
	}

	//----- TlC -----

	FData = &DList->file[FPos];
	flag = 0;
	if (!FData->thumb) {										// TlĈŃftHgACRZbg
		thumbImg = *gIconImg[getIconNo( FData->name2 )];
		thumbImg.wy -= 14;
		range = 0.5;
	} else {													// TlC
		thumbImg = *FData->thumb;
		if (FData->xSize > FData->ySize) {						// TlCɂ{vZ
			range = thumbImg.wx / (double)FData->xSize;
		} else {
			range = thumbImg.wy / (double)FData->ySize;
		}
		flag = 1;												// TlCʃtBbg邽߂̃tO
	}

	if (pv == NULL) {											// [h
		x1 = 0;
		y1 = 0;
		if (flag) {												// [hŃTlCꍇ
			if (thumbImg.wx / thumbImg.wy >= 1.78) {			// ʃTCYɍ킹邽߂̔{vZ
				range *= FData->xSize / (float)SCREEN_WIDTH;
			} else {
				range *= FData->ySize / (float)SCREEN_HEIGHT;
			}
		}
	} else {													// [h
		x1 = vinfo->startX;
		y1 = vinfo->startY;
		if (flag) {												// TlCȂ
			if (x == 0) {
				range *= vinfo->range;							// ƒ摜ƃTlC̔{𑵂
			} else {
				if (thumbImg.wx / thumbImg.wy >= 1.78) {		// ʃTCYɍ킹邽߂̔{vZ
					range *= FData->xSize / (float)SCREEN_WIDTH;
				} else {
					range *= FData->ySize / (float)SCREEN_HEIGHT;
				}
			}
		}
	}

	bakTex.tex = &thumbImg.data;
	bakTex.count = 1;
	bakTex.countX = 1;
	bakTex.width = thumbImg.wx;
	bakTex.height = thumbImg.wy;
	bakTex.widthAlign = thumbImg.width;
	blt( &bakTex, (SCREEN_WIDTH/2) - (bakTex.width/range/2) - x1 + x + 1,
	              (SCREEN_HEIGHT/2) - (bakTex.height/range/2) - y1,
	     range, 0 );

	//----- ƒ摜 -----

	picDraw( pv, vinfo, DList, FPos, x);
}

//===== wi惁C =====

static void imageDraw(strPicView *pv, strVInfo *vinfo, DirList *DList)
{
	int		x, FPos;

	FPos = vinfo->nowFPos;
	x = vinfo->nowX;
	if (gVData.drawEnd && x==0) {
		picDraw( pv, vinfo, DList, FPos, x);
	} else if (x == 0) {										// XChĂȂ
		backDraw( pv, vinfo, DList, FPos, x );					// 摜wiɃTlC摜g\
	} else if (x < 0) {											// XCh
		backDraw( pv, vinfo, DList, FPos, x );
		x += SCREEN_WIDTH;
		if (s2ch.cfg.keySwap) {									// 摜L[̓ւ
			FPos = backImage( DList, FPos );
		} else {
			FPos = nextImage( DList, FPos );
		}
		backDraw( pv, vinfo, DList, FPos, x );
	} else {													// XCh
		backDraw( pv, vinfo, DList, FPos, x );
		x -= SCREEN_WIDTH;
		if (s2ch.cfg.keySwap) {									// 摜L[̓ւ
			FPos = nextImage( DList, FPos );
		} else {
			FPos = backImage( DList, FPos );
		}
		backDraw( pv, vinfo, DList, FPos, x );
	}
}


//==============================================================
// 摜\C
//--------------------------------------------------------------
// ߂l 10F̂܂܌pĕ\
//        11FR}
//        12FR}
//--------------------------------------------------------------
// TlC摜擾ĂȂȂTlC쐬B
// ɗ]TȂkeNX`𐶐揈yB
//--------------------------------------------------------------

static int image2screen(strPicView *pv, strVInfo *vinfo, DirList *DList, char *thumbPath)
{
	int				padX, padY;
	int				ret = 10, sdFlag;
	double			rangeW, rangeH, rangeMin, bakX, bakY;
	int				imgWH, imgHW;
	int				width, height;

	width = pv->orgTex->width;
	height = pv->orgTex->height;

	if (gVData.mode == 1 || gVData.mode == 4) {
		makeThumb( pv, &DList->file[DList->pos], thumbPath );	// TlC摜Ȃ琶
	}

	sdFlag = 0;													// kω
	rangeW = (double)width / SCREEN_WIDTH;						// ʕɍ킹邽߂̊gk
	imgWH = height / rangeW;									// ʕɍ킹Ƃ̉摜
	rangeH = (double)height / SCREEN_HEIGHT;					// ʍɂ킹邽߂̊gk
	imgHW = width / rangeH;										// ʍɂ킹Ƃ̉摜
	rangeMin = 5;												// ők
	if (rangeMin < rangeW) rangeMin = rangeW;
	if (rangeMin < rangeH) rangeMin = rangeH;

	if (vinfo->reset) {											// ϐ̃Zbg
		vinfo->reset = 0;
		sdFlag = 1;												// kω
		vinfo->drawFlag = 1;									// ʂXV
		(vinfo->pauseFlag) = 0;									// AĐ[h
		switch (vinfo->sizeMode) {
		case 0:
			vinfo->range = rangeW;
			pv->width2 = SCREEN_WIDTH;
			pv->height2 = imgWH;
			vinfo->sizeModeSwap = 0;
			break;
		case 1:
			vinfo->range = rangeH;
			pv->width2 = imgHW;
			pv->height2 = SCREEN_HEIGHT;
			vinfo->sizeModeSwap = 0;
			break;
		case 2:
			vinfo->range = 1.0;
			pv->width2 = width;
			pv->height2 = height;
			vinfo->sizeModeSwap = 0;
			break;
		default:
			if (width / height >= 1.78) {
				vinfo->range = rangeW;
				pv->width2 = SCREEN_WIDTH;
				pv->height2 = imgWH;
				vinfo->sizeMode = 0;
				vinfo->sizeModeSwap = 0;
			} else {
				vinfo->range = rangeH;
				pv->width2 = imgHW;
				pv->height2 = SCREEN_HEIGHT;
				vinfo->sizeMode = 0;
				vinfo->sizeModeSwap = 1;						// 摜TCY̑JڂύX
			}
		}
		vinfo->startX = 0;
		vinfo->startY = 0;
	}

	bakX = vinfo->startX;
	bakY = vinfo->startY;										// \ʒuύXH̃`FbNp
	if (sceCtrlPeekBufferPositive( &s2ch.pad, 1 )) {
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			if (s2ch.oldPad.Buttons & PSP_CTRL_SQUARE && !(s2ch.pad.Buttons & PSP_CTRL_SQUARE)) {	// R}胂[h
				if (vinfo->cFlag) {
					vinfo->cFlag = 0;
				} else if (gVData.mode == 1 || gVData.mode == 2) {
					(vinfo->pauseFlag) ^= 1;
					vinfo->drawFlag = 1;						// ʂXV
				}
			}

			if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE) {
				(vinfo->sizeMode)++;
				if (vinfo->sizeMode > 2) {
					vinfo->sizeMode = 0;
				}
				switch (vinfo->sizeMode ^ vinfo->sizeModeSwap) {
				case 0:
					vinfo->range = rangeW;
					pv->width2 = SCREEN_WIDTH;
					pv->height2 = imgWH;
					break;
				case 1:
					vinfo->range = rangeH;
					pv->width2 = imgHW;
					pv->height2 = SCREEN_HEIGHT;
					break;
				default:
					vinfo->range = 1.0;
					pv->width2 = width;
					pv->height2 = height;
					break;
				}
				vinfo->startX = 0;
				vinfo->startY = 0;
				sdFlag = 1;										// kω
				vinfo->drawFlag = 1;							// ʂXV

			} else if (s2ch.pad.Buttons & PSP_CTRL_CROSS) {
				ret = COMPLETE;
				vinfo->drawFlag = 1;							// ʂXV

			} else if (s2ch.pad.Buttons & PSP_CTRL_TRIANGLE) {
				(vinfo->menu)++;
				if (vinfo->menu > 2) vinfo->menu = 0;
				vinfo->drawFlag = 1;							// ʂXV

			} else if (s2ch.pad.Buttons & PSP_CTRL_SELECT) {
				(vinfo->infoFlag) ^= 1;
				vinfo->drawFlag = 1;							// ʂXV

			} else if (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER ) {
				if (vinfo->pauseFlag) {							// R}胂[h
					ret = 12;
				} else {										// 摜p
					ret = SHIFT;
					vinfo->drawFlag = 1;						// ʂXV
				}

			} else if (s2ch.pad.Buttons & PSP_CTRL_LTRIGGER ) {
				if (vinfo->pauseFlag) {							// R}胂[h
					ret = 11;
				} else {										// 摜p
					ret = SHIFT;
					vinfo->drawFlag = 1;						// ʂXV
				}
			} else if (s2ch.pad.Buttons & PSP_CTRL_UP && s2ch.pad.Buttons & PSP_CTRL_SQUARE) {
				vinfo->filter ^= 1;								// X[WO̗L
				vinfo->cFlag = 1;								// Ƃ̓Ă
				vinfo->drawFlag = 1;							// ʂXV
			}
			s2ch.oldPad = s2ch.pad;
		}

		if (s2ch.pad.Buttons & PSP_CTRL_UP && !(s2ch.pad.Buttons & PSP_CTRL_SQUARE)) {
			vinfo->startY -= 2;
		}
		if (s2ch.pad.Buttons & PSP_CTRL_DOWN) {
			vinfo->startY += 2;
		}
		if (s2ch.pad.Buttons & PSP_CTRL_LEFT) {
			vinfo->startX -= 2;
		}
		if (s2ch.pad.Buttons & PSP_CTRL_RIGHT) {
			vinfo->startX += 2;
		}
		padX = s2ch.pad.Lx - 127;
		padY = s2ch.pad.Ly - 127;
		if (abs(padX) > s2ch.cfg.padCutoff) {
			if (s2ch.pad.Buttons & PSP_CTRL_SQUARE) {			// g嗦
				
			} else {											// \ʒu
				vinfo->startX += ((padX > 0) - (padX < 0)) * (abs(padX) - s2ch.cfg.padCutoff) / 8;
			}
		}
		if (abs(padY) > s2ch.cfg.padCutoff) {
			if (s2ch.pad.Buttons & PSP_CTRL_SQUARE) {			// g嗦
				int		x, y;
				x = vinfo->startX * vinfo->range;
				y = vinfo->startY * vinfo->range;				// {摜ł݈̌ʒu
				vinfo->range *= 1.0 + (padY) / 2400.0;
				if (vinfo->range > rangeMin) vinfo->range = rangeMin;
				if (vinfo->range < 0.2) vinfo->range = 0.2;
				pv->width2 = width / vinfo->range;
				pv->height2 = height / vinfo->range;
				vinfo->startX = x / vinfo->range;
				vinfo->startY = y / vinfo->range;				// {ύX̓ʒu
				vinfo->cFlag = 1;
				sdFlag = 1;										// kω
				vinfo->drawFlag = 1;							// ʂXV
			} else {											// \ʒu
				vinfo->startY += ((padY > 0) - (padY < 0)) * (abs(padY) - s2ch.cfg.padCutoff) / 8;
			}
		}
	}
	// width : 摜
	// height : 摜
	// width2 : \摜
	// height2 : \摜
	// startX.startY : \摜ɂ\Jnʒu
	if (pv->width2 <= SCREEN_WIDTH) {							// Xʒu␳
		vinfo->startX = 0;
	} else if (vinfo->startX < -(pv->width2 - SCREEN_WIDTH)/2) {
		vinfo->startX = -(pv->width2 - SCREEN_WIDTH) / 2;
	} else if (vinfo->startX > (pv->width2 - SCREEN_WIDTH)/2) {
		vinfo->startX = (pv->width2 - SCREEN_WIDTH) / 2;
	}
	if (pv->height2 <= SCREEN_HEIGHT) {							// Yʒu␳
		vinfo->startY = 0;
	} else if (vinfo->startY < -(pv->height2 - SCREEN_HEIGHT)/2) {
		vinfo->startY = -(pv->height2 - SCREEN_HEIGHT) / 2;
	} else if (vinfo->startY > (pv->height2 - SCREEN_HEIGHT)/2) {
		vinfo->startY = (pv->height2 - SCREEN_HEIGHT) / 2;
	}
	if (bakX != vinfo->startX || bakY != vinfo->startY) {
		vinfo->drawFlag = 1;									// ʂXV
	}

	//----- keNX` -----
	// Ȃꍇ͏keNX`͐Ȃ

	if (!gVData.sdFlag) {										// keNX`̐͋֎~Ă
		freeSdTex( pv );
	} else if (sdFlag || vinfo->sdDrawFlag) {
		unsigned int	i;
		int				range;
		sdFlag = 0;
		if (vinfo->range < 2.0) {
			range = vinfo->range + 0.65;						// ߂ɏks敉ׂy
		} else {
			range = vinfo->range;
		}
		if (pv->orgTex->countX / range < 1) {					// kȂ悤
			range = pv->orgTex->countX;
		}
		if (pv->orgTex->height < TEX_HEIGHT*2 && pv->orgTex->width < BUF_WIDTH*1.5) {
			range = 0;											// 摜ȂkȂ
		}
		if (range <= 1) {										// k2Ȃ̂ŏkeNX`폜
			freeSdTex( pv );
		}

		if (range>=2 && (range!=pv->sdThumb || vinfo->sdDrawFlag)) {	// k2ȏŏkeNX`̏kƈĂȂ
			vinfo->sdDrawFlag = 0;
			freeSdTex( pv );									// keNX`݂ĂȂ폜
			if (getTexMem( &pv->sdTex, pv->orgTex->width / range, pv->orgTex->height / range ) == 0) {
				Color			*sdP, *orgP;
				unsigned int	orgCount, orgY;
				unsigned int	sdCount, sdY, sdX, sdTexCount;
				unsigned int	a, x;
				pv->sdThumb = range;										// keNX`̏k
				orgY = 0;
				sdY = 0;
				a = BUF_WIDTH / range;
				if (a % range) a++;											// _ȉ͐؂グ
				for (orgY = 0; orgY < pv->orgTex->height; orgY += range) {
					sdCount = (sdY / TEX_HEIGHT) * pv->sdTex.countX;
					if (pv->sdTex.countX == 1) {
						sdP = pv->sdTex.tex[sdCount++] + (sdY % TEX_HEIGHT) * pv->sdTex.widthAlign;
					} else {
						sdP = pv->sdTex.tex[sdCount++] + (sdY % TEX_HEIGHT) * BUF_WIDTH;
					}
					orgCount = (orgY / TEX_HEIGHT) * pv->orgTex->countX;
					sdX = 0;
					sdTexCount = 0;
					for (x = pv->orgTex->width; x >= BUF_WIDTH; x -= BUF_WIDTH) {
						orgP = pv->orgTex->tex[orgCount++] + (orgY % TEX_HEIGHT) * BUF_WIDTH;
						for (i = 0; i < a; i++) {							// eNX`512hbgRs[
							*sdP++ = *orgP;
							orgP += range;
						}
						sdX += a;
						if (sdX >= BUF_WIDTH) {								// keNX`̃Rs[؂ւ
							sdX = 0;
							sdTexCount++;
							if (sdTexCount == pv->sdTex.countX-1) {
								sdP = pv->sdTex.tex[sdCount++] + (sdY % TEX_HEIGHT) * pv->sdTex.widthAlign;
							} else {
								sdP = pv->sdTex.tex[sdCount++] + (sdY % TEX_HEIGHT) * BUF_WIDTH;
							}
						}
					}
					orgP = pv->orgTex->tex[orgCount] + (orgY % TEX_HEIGHT) * pv->orgTex->widthAlign;
					for (i = 0; i < x/range + ((x % range)!=0); i++) {		// eNX`[hbgRs[
						*sdP++ = *orgP;
						orgP += range;
					}
					sdY++;
				}
			}
		}
	}

	//----- ʕ\ -----

	if (vinfo->drawFlag) {										// ʂXVƂsiȓd͏j
		vinfo->drawFlag = 0;
		guStart();
		sceGuClearColor( s2ch.BakCor );
		sceGuClearDepth( 0 );
		sceGuClear( GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT );
		imageDraw( pv, vinfo, DList );							// 摜\

		if ((ret == SHIFT || ret == COMPLETE) && vinfo->nowX == 0 && (gVData.mode==2 || gVData.mode==4)) {
			sceGuFinish();
			sceGuSync( 0, 0 );
			blitScreenToImage( 1, 0, 0, 480, 272, gScrBuf1, 0, 0 );	// wiҔ
			guStart();
			vinfo->backFPos = vinfo->FPos;						// wi摜XVꂽ
			vinfo->backImgDis = 0;								// 擾wi摜͗L
		}
		vinfo->viewFlag = 1;
	}

	return ret;
}


//==============================================================
// jpegt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

static int psp2chImageViewJpeg(char *data, unsigned long length, strPicView *pv, char *info)
{
	JSAMPROW						buf = NULL;
	unsigned long					width, height, i;
	int								ret = COMPLETE;
	unsigned int					drawTime;
	struct jpeg_decompress_struct	cinfo;
	struct my_error_mgr				jerr;

	cinfo.err = jpeg_std_error( &jerr.pub );

	if ((u8)data[0] != 0xFF || (u8)data[1] != 0xD8) {
		return HEAD_ERR;
	}
	pv->orgTex->tex = NULL;										// eNX`͐ĂȂ
	pv->sdTex.tex = NULL;										// keNX`͐ĂȂ
	pv->sdThumb = 0;

	jerr.pub.error_exit = my_error_exit;
	if (setjmp(jerr.setjmp_buffer)) {							/* error̃Wv */
		ret = LIB_ERR;
		sprintf( info, "fR[hƒɃG[" );
		goto jpeg_Error;
	}

	//----- ݒ -----

	drawTime = clock();
	jpeg_create_decompress( &cinfo );
	jpeg_memory_src( &cinfo, (void*)data, length );
	jpeg_read_header( &cinfo, TRUE );
	jpeg_calc_output_dimensions( &cinfo );
	jpeg_start_decompress( &cinfo );

	ret = getTexMem( pv->orgTex, cinfo.output_width, cinfo.output_height );
	if (ret == MEM_ERR) {										// eNX`z̊mۂɎs
		sprintf( info, "eNX`z̊mۂɎs" );
		goto jpeg_Error;
	}
	buf = memalign( 16, sizeof(JSAMPLE) * cinfo.output_components * pv->orgTex->width );
	if (!buf) {
		ret = MEM_ERR;
		sprintf( info, "fR[hƗ̈̊mۂɎs" );
		goto jpeg_Error;
	}

	//----- RGBJ[RGBA -----

	gVData.mode = 3;											// fR[hJn

	if (cinfo.out_color_components == 3) {
		unsigned char	*imgP, *bufP;
		int				count;
		height = 0;
		while (cinfo.output_scanline < pv->orgTex->height) {
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				goto jpeg_Error;
			}
			jpeg_read_scanlines( &cinfo, &buf, 1 );
			bufP = buf;
			count = ((cinfo.output_scanline - 1) / TEX_HEIGHT) * pv->orgTex->countX;
			for (width = pv->orgTex->width; width >= BUF_WIDTH; width -= BUF_WIDTH) {
				imgP = (unsigned char*)pv->orgTex->tex[count++] + height * 4 * BUF_WIDTH;
				for (i = 0; i < BUF_WIDTH; i++) {
					*imgP++ = *bufP++;
					*imgP++ = *bufP++;
					*imgP++ = *bufP++;
					*imgP++ = 0xFF;
				}
			}
			imgP = (unsigned char*)pv->orgTex->tex[count] + height * 4 * pv->orgTex->widthAlign;
			for (i = 0; i < width; i++) {
				*imgP++ = *bufP++;
				*imgP++ = *bufP++;
				*imgP++ = *bufP++;
				*imgP++ = 0xFF;
			}
			height++;
			if (height >= TEX_HEIGHT) height = 0;
//			DoEvent();											// obNXbhiBGMXbh쓮pj
		}
	}

	//----- O[XP[RGBA -----

	else if (cinfo.out_color_components == 1) {
		unsigned char	*imgP, *bufP;
		int				count;
		height = 0;
		while (cinfo.output_scanline < pv->orgTex->height) {
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				goto jpeg_Error;
			}
			jpeg_read_scanlines( &cinfo, &buf, 1 );
			bufP = buf;
			count = ((cinfo.output_scanline - 1) / TEX_HEIGHT) * pv->orgTex->countX;
			for (width = pv->orgTex->width; width >= BUF_WIDTH; width -= BUF_WIDTH) {
				imgP = (unsigned char*)pv->orgTex->tex[count++] + height * 4 * BUF_WIDTH;
				for (i = 0; i < BUF_WIDTH; i++) {
					*imgP++ = *bufP;
					*imgP++ = *bufP;
					*imgP++ = *bufP++;
					*imgP++ = 0xFF;
				}
			}
			imgP = (unsigned char*)pv->orgTex->tex[count] + height * 4 * pv->orgTex->widthAlign;
			for (i = 0; i < width; i++) {
				*imgP++ = *bufP;
				*imgP++ = *bufP;
				*imgP++ = *bufP++;
				*imgP++ = 0xFF;
			}
			height++;
			if (height >= TEX_HEIGHT) height = 0;
//			DoEvent();											// obNXbhiBGMXbh쓮pj
		}
	}
	else {
		ret = SUP_ERR;
		sprintf( info, "ΉĂ̂RGBJ[ƃO[XP[̂" );
		goto jpeg_Error;
	}
	free( buf );
	buf = NULL;
	jpeg_finish_decompress( &cinfo );

	//----- \ -----

	drawTime = clock() - drawTime;
	sprintf( info, "t@CTCY  %d[KB]\n摜TCY  X=%d Y=%d\nJ[  %d\nfR[h  %d[ms]\n"
	               "eNX`  %d",
	               (int)length/1024, pv->orgTex->width, pv->orgTex->height, cinfo.out_color_components, drawTime/1000,
	               pv->orgTex->count
	       );

	//----- I -----

jpeg_Error:
	free( buf );
	jpeg_destroy_decompress( &cinfo );
	gVData.drawEnd = 1;											// 摜fR[hI
	return ret;
}

//==============================================================
// PNGt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

static int psp2chImageViewPng(char *data, unsigned long length, strPicView *pv, char *info)
{
	my_img_buffer	png_buf;
	png_structp		png_ptr;
	png_infop		info_ptr;
	png_infop		end_info;
	unsigned long	width, height, i, j;
	int				bit_depth, color_type, interlace_type, ret = COMPLETE;
	png_bytep		imgbuf = NULL;
	unsigned int	drawTime;

	//----- ݒ -----

	drawTime = clock();
	pv->orgTex->tex = NULL;										// eNX`͐ĂȂ
	pv->sdTex.tex = NULL;										// keNX`͐ĂȂ
	pv->sdThumb = 0;

	png_buf.data = (unsigned char*)data;
	png_buf.length = length;
	// PNG`FbN
	if (png_sig_cmp((png_bytep)png_buf.data, 0, PNG_BYTES_TO_CHECK) != 0) {
		return HEAD_ERR;
	}
	png_buf.offset = PNG_BYTES_TO_CHECK;
	png_buf.data += PNG_BYTES_TO_CHECK;
	png_ptr = png_create_read_struct( PNG_LIBPNG_VER_STRING, NULL, NULL, NULL );
	info_ptr = png_create_info_struct( png_ptr );
	end_info = png_create_info_struct( png_ptr );
	//G[nh
	if (setjmp(png_ptr->jmpbuf)) {
		sprintf( info, "fR[hƒɃG[" );
		ret = LIB_ERR;
		goto png_Error;
	}
	// IOύX
	png_set_read_fn( png_ptr, (void*)&png_buf, (png_rw_ptr)png_memread_func );
	png_set_error_fn( png_ptr, NULL, myPngError, NULL );
	png_set_sig_bytes( png_ptr, PNG_BYTES_TO_CHECK );
	png_read_info( png_ptr, info_ptr );
	png_get_IHDR( png_ptr, info_ptr, &width, &height, &bit_depth, &color_type, &interlace_type, NULL, NULL );

	//pbgn->RGBnɊg
	if (color_type == PNG_COLOR_TYPE_PALETTE ||
	       (color_type == PNG_COLOR_TYPE_GRAY && bit_depth < 8) ||
	       png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS)) {
		png_set_expand( png_ptr );
	}
	//16rbg->8rbgɗƂ
	if (bit_depth > 8) {
		png_set_strip_16( png_ptr );
	}
	//O[XP[->RGBɊg
	if (color_type==PNG_COLOR_TYPE_GRAY || color_type==PNG_COLOR_TYPE_GRAY_ALPHA) {
		png_set_gray_to_rgb( png_ptr );
	}
	if (color_type != PNG_COLOR_TYPE_RGB_ALPHA && color_type!=PNG_COLOR_TYPE_GRAY_ALPHA) {
		png_set_add_alpha( png_ptr, 0xFFFF, PNG_FILLER_AFTER );
	}
	png_read_update_info(png_ptr, info_ptr);

	ret = getTexMem( pv->orgTex, info_ptr->width, info_ptr->height );
	if (ret == MEM_ERR) {										// eNX`z̊mۂɎs
		sprintf( info, "eNX`z̊mۂɎs" );
		goto png_Error;
	}
	imgbuf = memalign( 16, pv->orgTex->width * sizeof(png_bytep) * 4 );
	if (!imgbuf) {
		ret = MEM_ERR;
		sprintf( info, "fR[hƗ̈̊mۂɎs" );
		goto png_Error;
	}

	//----- 摜擾 -----

	gVData.mode = 3;											// fR[hJn

	height = 0;
	for (j = 0; j < pv->orgTex->height; j++) {
		Color	*imgP, *bufP;
		int		count;
		if (gVData.cancelFlag) {							// LZ
			ret = CANCEL;
			goto png_Error;
		}
		png_read_row( png_ptr, imgbuf, NULL );
		bufP = (Color*)imgbuf;
		count = (j / TEX_HEIGHT) * pv->orgTex->countX;
		for (width = pv->orgTex->width; width >= BUF_WIDTH; width -= BUF_WIDTH) {
			imgP = pv->orgTex->tex[count++] + height * BUF_WIDTH;
			for (i = 0; i < BUF_WIDTH; i++) {
				*imgP++ = *bufP++;
			}
		}
		imgP = pv->orgTex->tex[count] + height * pv->orgTex->widthAlign;
		for (i = 0; i < width; i++) {
			*imgP++ = *bufP++;
		}
		height++;
		if (height >= TEX_HEIGHT) height = 0;
//		DoEvent();											// obNXbhiBGMXbh쓮pj
	}
	png_read_end( png_ptr, end_info );
	drawTime = clock() - drawTime;

	//----- \ -----

	if (info) {
		sprintf( info, "t@CTCY  %d[KB]\n摜TCY  X=%d Y=%d\nJ[  %X\nrbg  %d\nC^[[X  %d\nfR[h  %d[ms]",
		               (int)length/1024, pv->orgTex->width, pv->orgTex->height, color_type, bit_depth, interlace_type, drawTime/1000
		       );
	}

	//----- I -----

png_Error:
	png_destroy_read_struct( &png_ptr, &info_ptr, &end_info );
	if (imgbuf) free( imgbuf );
	gVData.drawEnd = 1;											// 摜fR[hI
	return ret;
}

//==============================================================
// BMPt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

static int psp2chImageViewBmp(char *data, unsigned long length, strPicView *pv, char *info)
{
	unsigned char		*bmp_data, *p1, *p2;
	int					i, j, y, height, len, ret = COMPLETE;
	BITMAPFILEHEADER	bf;
	BITMAPINFOHEADER	bi;
	unsigned int		drawTime;
	Color				*palette = NULL;

	//-----  -----

	drawTime = clock();
	pv->orgTex->tex = NULL;										// eNX`͐ĂȂ
	pv->sdTex.tex = NULL;										// keNX`͐ĂȂ
	pv->sdThumb = 0;

	bmp_data = (unsigned char*)data;
	memcpy( &bf, bmp_data, sizeof(BITMAPFILEHEADER) );
	bmp_data += sizeof(BITMAPFILEHEADER);
	if (memcmp(bf.bfType, "BM", 2) != 0) {
		sprintf( info, "BMPwb_[iBMPt@Cł͂Ȃj" );
		return HEAD_ERR;
	}
	memcpy( &bi, bmp_data, sizeof(BITMAPINFOHEADER) );
	bmp_data += sizeof(BITMAPINFOHEADER);
	if (bi.biCompression) {
		sprintf( info, "̌`ɂ͑ΉĂ܂\nbiCompression:%d", (int)bi.biCompression );
		return SUP_ERR;											// k摜ɂ͑ΉĂȂ
	}
	if (bi.biHeight < 0) {
		height = -bi.biHeight;
	}
	else {
		height = bi.biHeight;
	}
	if (bi.biClrUsed == 0) {
		if (bi.biBitCount <= 8) {
			len = 1 << bi.biBitCount;
		} else {
			len = 0;
		}
	} else {
		len = bi.biClrUsed;
	}
	if (len) {													// J[pbg݂ꍇ
		palette = malloc( sizeof(RGBQUAD) * len );
		if (!palette) {											// J[pbgpmۏoȂ
			ret = MEM_ERR;
			sprintf( info, "pbg̈̊mۂɎs\nF:%d", len );
			goto bmp_Error;
		}
		p1 = (unsigned char*)palette;
		p2 = bmp_data;
		for (i = 0; i < len; i++) {								// J[pbgRGBAzɕϊăRs[
			*p1++ = p2[2];
			*p1++ = p2[1];
			*p1++ = p2[0];
			*p1++ = 0xFF;
			p2 += sizeof(RGBQUAD);
		}
		bmp_data += sizeof(RGBQUAD) * len;
	}

	ret = getTexMem( pv->orgTex, bi.biWidth, height );
	if (ret == MEM_ERR) {										// eNX`z̊mۂɎs
		sprintf( info, "eNX`z̊mۂɎs" );
		goto bmp_Error;
	}
	len = bi.biWidth * bi.biBitCount / 8;
	len += (4 - (len & 3)) & 3;
	bmp_data = (unsigned char*)data + bf.bfOffBits;

	gVData.mode = 3;											// fR[hJn

	//----- 24/32rbgBMPRGBA -----

	switch (bi.biBitCount) {
		int		texX, texY, step;
	case 32:
	case 24:
		if (bi.biBitCount == 24) {
			step = 3;
		} else {
			step = 4;
		}
		for (j = 0; j < (int)pv->orgTex->height; j++) {
			unsigned char	*imgP, *bufP;
			int		count;
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				break;
			}
			if (bi.biHeight < 0) {
				y = j;
			} else {
				y = height - j - 1;
			}
			texY = y % TEX_HEIGHT;
			bufP = bmp_data;
			bmp_data += len;
			count = (y / TEX_HEIGHT) * pv->orgTex->countX;
			for (texX = pv->orgTex->width; texX >= BUF_WIDTH; texX -= BUF_WIDTH) {
				imgP = (u8*)(pv->orgTex->tex[count++] + texY * BUF_WIDTH);
				for (i = 0; i < BUF_WIDTH; i++) {
					const int	a = i * step;
					*imgP++ = bufP[a + 2];
					*imgP++ = bufP[a + 1];
					*imgP++ = bufP[a + 0];
					*imgP++ = 0xFF;
				}
			}
			imgP = (u8*)(pv->orgTex->tex[count] + texY * pv->orgTex->widthAlign);
			for (i = 0; i < texX; i++) {
				const int	a = i * step;
				*imgP++ = bufP[a + 2];
				*imgP++ = bufP[a + 1];
				*imgP++ = bufP[a + 0];
				*imgP++ = 0xFF;
			}
		}
		break;

	//----- 16rbgBMPRGBA -----

	case 16:
		for (j = 0; j < (int)pv->orgTex->height; j++) {
			unsigned char	*imgP;
			u16				*bufP, cor;
			int		count;
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				break;
			}
			if (bi.biHeight < 0) {
				y = j;
			} else {
				y = height - j - 1;
			}
			texY = y % TEX_HEIGHT;
			bufP = (u16*)bmp_data;
			bmp_data += len;
			count = (y / TEX_HEIGHT) * pv->orgTex->countX;
			for (texX = pv->orgTex->width; texX >= BUF_WIDTH; texX -= BUF_WIDTH) {
				imgP = (u8*)(pv->orgTex->tex[count++] + texY * BUF_WIDTH);
				for (i = 0; i < BUF_WIDTH; i++) {
					cor = *bufP++;
					*imgP++ = (cor >> 10 & 0x1F) * 255 / 31;
					*imgP++ = (cor >> 5 & 0x1F) * 255 / 31;
					*imgP++ = (cor & 0x1F) * 255 / 31;
					*imgP++ = 0xFF;
				}
			}
			imgP = (u8*)(pv->orgTex->tex[count] + texY * pv->orgTex->widthAlign);
			for (i = 0; i < texX; i++) {
				cor = *bufP++;
				*imgP++ = (cor >> 10 & 0x1F) * 255 / 31;
				*imgP++ = (cor >> 5 & 0x1F) * 255 / 31;
				*imgP++ = (cor & 0x1F) * 255 / 31;
				*imgP++ = 0xFF;
			}
		}
		break;

	//----- 8rbgBMPRGBA -----

	case 8:
		for (j = 0; j < (int)pv->orgTex->height; j++) {
			unsigned char	*bufP;
			Color			*imgP;
			int		count;
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				break;
			}
			if (bi.biHeight < 0) {
				y = j;
			} else {
				y = height - j - 1;
			}
			texY = y % TEX_HEIGHT;
			bufP = bmp_data;
			bmp_data += len;
			count = (y / TEX_HEIGHT) * pv->orgTex->countX;
			for (texX = pv->orgTex->width; texX >= BUF_WIDTH; texX -= BUF_WIDTH) {
				imgP = pv->orgTex->tex[count++] + texY * BUF_WIDTH;
				for (i = 0; i < BUF_WIDTH; i++) {
					*imgP++ = palette[bufP[i]];
				}
			}
			imgP = pv->orgTex->tex[count] + texY * pv->orgTex->widthAlign;
			for (i = 0; i < texX; i++) {
				*imgP++ = palette[bufP[i]];
			}
		}
		break;

	//----- 4rbgBMPRGBA -----

	case 4:
		for (j = 0; j < (int)pv->orgTex->height; j++) {
			unsigned char	*bufP, cor;
			Color			*imgP;
			int		count;
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				break;
			}
			if (bi.biHeight < 0) {
				y = j;
			} else {
				y = height - j - 1;
			}
			texY = y % TEX_HEIGHT;
			bufP = bmp_data;
			bmp_data += len;
			count = (y / TEX_HEIGHT) * pv->orgTex->countX;
			for (texX = pv->orgTex->width; texX >= BUF_WIDTH; texX -= BUF_WIDTH) {
				imgP = pv->orgTex->tex[count++] + texY * BUF_WIDTH;
				for (i = 0; i < BUF_WIDTH / 2; i++) {
					cor = bufP[i];
					*imgP++ = palette[cor >> 4];
					*imgP++ = palette[cor & 0x0F];
				}
			}
			imgP = pv->orgTex->tex[count] + texY * pv->orgTex->widthAlign;
			for (i = 0; i < texX / 2; i++) {
				cor = bufP[i];
				*imgP++ = palette[cor >> 4];
				*imgP++ = palette[cor & 0x0F];
			}
		}
		break;

	//----- 1rbgBMPRGBA -----

	case 1:
		for (j = 0; j < (int)pv->orgTex->height; j++) {
			unsigned char	*bufP, cor;
			Color			*imgP;
			int		count;
			if (gVData.cancelFlag) {							// LZ
				ret = CANCEL;
				break;
			}
			if (bi.biHeight < 0) {
				y = j;
			} else {
				y = height - j - 1;
			}
			texY = y % TEX_HEIGHT;
			bufP = bmp_data;
			bmp_data += len;
			count = (y / TEX_HEIGHT) * pv->orgTex->countX;
			for (texX = pv->orgTex->width; texX >= BUF_WIDTH; texX -= BUF_WIDTH) {
				imgP = pv->orgTex->tex[count++] + texY * BUF_WIDTH;
				for (i = 0; i < BUF_WIDTH / 8; i++) {
					cor = bufP[i];
					*imgP++ = palette[cor >> 8];
					*imgP++ = palette[cor >> 7 & 0x01];
					*imgP++ = palette[cor >> 6 & 0x01];
					*imgP++ = palette[cor >> 5 & 0x01];
					*imgP++ = palette[cor >> 4 & 0x01];
					*imgP++ = palette[cor >> 3 & 0x01];
					*imgP++ = palette[cor >> 2 & 0x01];
					*imgP++ = palette[cor >> 1 & 0x01];
					*imgP++ = palette[cor & 0x01];
				}
			}
			imgP = pv->orgTex->tex[count] + texY * pv->orgTex->widthAlign;
			for (i = 0; i < texX / 8; i++) {
				cor = bufP[i];
				*imgP++ = palette[cor >> 8];
				*imgP++ = palette[cor >> 7 & 0x01];
				*imgP++ = palette[cor >> 6 & 0x01];
				*imgP++ = palette[cor >> 5 & 0x01];
				*imgP++ = palette[cor >> 4 & 0x01];
				*imgP++ = palette[cor >> 3 & 0x01];
				*imgP++ = palette[cor >> 2 & 0x01];
				*imgP++ = palette[cor >> 1 & 0x01];
				*imgP++ = palette[cor & 0x01];
			}
		}
		break;

	//----- Ήiʏ͂蓾Ȃj -----

	default:
		ret = SUP_ERR;
		sprintf( info, "̐Fɂ͑ΉĂ܂\nBitCount:%d[bit]", bi.biBitCount );
		goto bmp_Error;
	}
	drawTime = clock() - drawTime;

	//----- \ -----

	sprintf( info, "t@CTCY  %d[KB]\n摜TCY  X=%d Y=%d\nJ[  %d\nk  %d\nfR[h  %d[ms]",
	               (int)length/1024, pv->orgTex->width, pv->orgTex->height, bi.biBitCount, (int)bi.biCompression, drawTime/1000
	       );

	//----- I -----

bmp_Error:
	free( palette );
	gVData.drawEnd = 1;											// 摜fR[hI
	return ret;
}


//==============================================================
// GIFt@Cǂݍ32rbgRGBAɕϊ
//--------------------------------------------------------------

//===== pbgC[Wx^摜ɕϊ =====

static void img2pic(strPicView *pv, struct strGif gif)
{
	int				i, x, y2, count, width, height;
	Color			*imgP;
	GifRowType		GifRow;
	strTex			*orgTex;

	if (gVData.aniPage) {										// GIFWJeNX`̑I
		orgTex = &pv->orgTex2;
	} else {
		orgTex = &pv->orgTex1;
	}
	GifRow = gif.ImgBuf;
	height = gif.top+gif.height;
	width = gif.left+gif.width;
	for (i = gif.top; i < height; i++) {						// pbgC[Wx^摜
		y2 = i % TEX_HEIGHT;
		count = (i / TEX_HEIGHT) * orgTex->countX + gif.left / BUF_WIDTH;
		if (gif.left >= (int)(orgTex->countX-1)*BUF_WIDTH) {
			imgP = orgTex->tex[count++] + (y2 * orgTex->widthAlign + gif.left) ;
		} else {
			imgP = orgTex->tex[count++] + (y2 * BUF_WIDTH + gif.left);
		}
		for (x = gif.left; x < width; x++) {
			if (*GifRow != gif.transparent) {					// Fł͂Ȃ
				*imgP++ = gif.Colors[*GifRow];
			} else {											// F
				imgP++;
			}
			GifRow++;
			if ((x & BUF_WIDTH_BIT) == BUF_WIDTH_BIT) {			// if ((x % BUF_WIDTH) == BUF_WIDTH-1) { ƒx̂
				if (x >= (int)(orgTex->countX-1)*BUF_WIDTH-1) {
					imgP = orgTex->tex[count++] + y2 * orgTex->widthAlign;
				} else {
					imgP = orgTex->tex[count++] + y2 * BUF_WIDTH;
				}
			}
		}
	}
}

//===== GIFfR[h =====

static int psp2chImageViewGif(char *data, unsigned long length, strPicView *pv, char *info)
{
	int				InterlacedOffset[] = { 0, 4, 2, 1 };		/* The way Interlaced image should. */
	int				InterlacedJumps[] = { 8, 8, 4, 2 };			/* be read - offsets and jumps... */
	int				i, j, Row, Col, Width, Height, ExtCode, ret = COMPLETE;
	int				reset, err = 0, gifErr = 0, errEOF = 0, memErr, cormap = 0;
	int				frameCnt, imgCount = 0, colorCount, SHeight, SWidth;
	int				transparent = -1, delaytime;
	unsigned int	nextTime, oldClock, frameClock, frameTime, drawClock, drawTime;
	my_img_buffer	gif_buf;
	GifFileType		*GifFile;
	GifRecordType	RecordType;
	GifByteType		*Extension;
	ColorMapObject	*ColorMap;
	GifColorType	cp;
	unsigned char	*corP;

	struct strGif	*gif = NULL, *gifTmp = NULL, *gifTop = NULL;	// GIF̊epbgL^C[Wobt@
	struct strGif	*gifSub = NULL;									// ƃ̎擾ɎsɎgp

	struct {
		int		id;												// G[R[h
		char	*msg;											// G[bZ[W
	} gifErrMsg[] = {
		{ E_GIF_ERR_OPEN_FAILED,	"E_GIF_ERR_OPEN_FAILED" },	// encode error list
		{ E_GIF_ERR_WRITE_FAILED,	"E_GIF_ERR_WRITE_FAILED" },
		{ E_GIF_ERR_HAS_SCRN_DSCR,	"E_GIF_ERR_HAS_SCRN_DSCR" },
		{ E_GIF_ERR_HAS_IMAG_DSCR,	"E_GIF_ERR_HAS_IMAG_DSCR" },
		{ E_GIF_ERR_NO_COLOR_MAP,	"E_GIF_ERR_NO_COLOR_MAP" },
		{ E_GIF_ERR_DATA_TOO_BIG,	"E_GIF_ERR_DATA_TOO_BIG" },
		{ E_GIF_ERR_NOT_ENOUGH_MEM,	"E_GIF_ERR_NOT_ENOUGH_MEM" },
		{ E_GIF_ERR_DISK_IS_FULL,	"E_GIF_ERR_DISK_IS_FULL" },
		{ E_GIF_ERR_CLOSE_FAILED,	"E_GIF_ERR_CLOSE_FAILED" },
		{ E_GIF_ERR_NOT_WRITEABLE,	"E_GIF_ERR_NOT_WRITEABLE" },

		{ D_GIF_ERR_OPEN_FAILED,	"D_GIF_ERR_OPEN_FAILED" },	// decode error list
		{ D_GIF_ERR_READ_FAILED,	"D_GIF_ERR_READ_FAILED" },
		{ D_GIF_ERR_NOT_GIF_FILE,	"D_GIF_ERR_NOT_GIF_FILE" },
		{ D_GIF_ERR_NO_SCRN_DSCR,	"D_GIF_ERR_NO_SCRN_DSCR" },
		{ D_GIF_ERR_NO_IMAG_DSCR,	"D_GIF_ERR_NO_IMAG_DSCR" },
		{ D_GIF_ERR_NO_COLOR_MAP,	"D_GIF_ERR_NO_COLOR_MAP" },
		{ D_GIF_ERR_WRONG_RECORD,	"D_GIF_ERR_WRONG_RECORD" },
		{ D_GIF_ERR_DATA_TOO_BIG,	"D_GIF_ERR_DATA_TOO_BIG" },
		{ D_GIF_ERR_NOT_ENOUGH_MEM,	"D_GIF_ERR_NOT_ENOUGH_MEM" },
		{ D_GIF_ERR_CLOSE_FAILED,	"D_GIF_ERR_CLOSE_FAILED" },
		{ D_GIF_ERR_NOT_READABLE,	"D_GIF_ERR_NOT_READABLE" },
		{ D_GIF_ERR_IMAGE_DEFECT,	"D_GIF_ERR_IMAGE_DEFECT" },
		{ D_GIF_ERR_EOF_TOO_SOON,	"D_GIF_ERR_EOF_TOO_SOON" },
		{ 0,						"̑" }
	};

	//----- ݒ -----

	gVData.sdFlag = 0;											// keNX`͐Ȃ
	pv->orgTex->tex = NULL;										// eNX`͐ĂȂ
	pv->sdTex.tex = NULL;										// keNX`͐ĂȂ
	pv->sdThumb = 0;

	gif_buf.data = (unsigned char*)data;
	gif_buf.length = length;
	gif_buf.offset = 0;
	if ((GifFile = DGifOpen(&gif_buf, gif_data_read_func)) == NULL)
	{
		strcpy( info, "DGifOpen" );
		ret = LIB_ERR;
		err = -1;
		goto gif_Error2;
	}
	SWidth = GifFile->SWidth;									// 摜XTCY
	SHeight = GifFile->SHeight;									// 摜YTCY
	gifSub = malloc( sizeof(struct strGif) );
	if (gifSub) {
		gifSub->ImgBuf = memalign( 16, SWidth * SHeight );
		gifSub->Colors = malloc( 256 * sizeof(Color) );
		if (!gifSub->ImgBuf || !gifSub->Colors) {
			free( gifSub->ImgBuf );
			free( gifSub->Colors );
			ret = MEM_ERR;
		}
	} else {
		ret = MEM_ERR;
	}
	if (ret == MEM_ERR) {
		sprintf( info, "\\̃pbg̈mۂ鎖Ɏs" );
		goto gif_Error;
	}

	ret = getTexMem( &pv->orgTex1, SWidth, SHeight );
	if (ret == MEM_ERR) {										// eNX`z̊mۂɎs
		sprintf( info, "eNX`z̊mۂɎs" );
		goto gif_Error;
	}
//	getTexMem( &pv->orgTex2, SWidth, SHeight );					// ƗpeNX`pӁimۂɎsĂ悢j

	//----- GIF摜fR[hʕ\sApbgC[WLbV -----
	// rłPłmۂɎsLbV𒆎~ʕ\p

	gVData.mode = 3;											// fR[hJn

	nextTime = clock();
	frameClock = clock();
	reset = 1;													// 摜\ʒũZbgw
	memErr = 0;
	imgCount = 0;												// C[W̑JEgp
	colorCount = 0;
	gVData.anime = 0;											// ŏGIFÎ~ƂĈ
	transparent = -1;											// 
	delaytime = -1;												// ExtensionȗĂꍇւ̑Ή
	gifTmp = NULL;
	do {
		frameCnt = 0;											// 摜JEgp
		do {
			if (DGifGetRecordType(GifFile, &RecordType) == GIF_ERROR) {
				strcpy( info, "RT-DecodeMode DGifGetRecordType" );
				ret = LIB_ERR;
				err = -1;
				goto gif_Error;
			}
			switch (RecordType) {
			case IMAGE_DESC_RECORD_TYPE:
				drawClock = clock();
				if (DGifGetImageDesc(GifFile) == GIF_ERROR) {
					strcpy( info, "RT-DecodeMode DGifGetImageDesc" );
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
				if (GifFile->Image.ColorMap) cormap = 1;
				ColorMap = (GifFile->Image.ColorMap ? GifFile->Image.ColorMap : GifFile->SColorMap);
				if (!ColorMap) {
					strcpy( info, "RT-DecodeMode ColorMap NULL" );
					ret = SUP_ERR;
					err = -1;
					goto gif_Error;
				}
				if (colorCount < ColorMap->ColorCount) {
					colorCount = ColorMap->ColorCount;							// gppbg
				}
				Row = GifFile->Image.Top;										/* Image Position relative to Screen. */
				Col = GifFile->Image.Left;
				Height = GifFile->Image.Height;
				Width = GifFile->Image.Width;
				if (!memErr) {													// ̊mۂɎsĂȂ̂Ȃ
					gif = malloc( sizeof(struct strGif) );
					if (!gif) {													// ̊mۂɎs
						memErr = -1;
					} else {
						if (!gifTop) {											// ꂪŏ̃pbgȂ
							gifTop = gif;
						}
						if (gifTmp) {											// Õpbg񂪍݂Ȃ`FCq
							gifTmp->next = gif;
						}
						gif->ImgBuf = memalign( 16, Width * Height );
						gif->Colors = malloc( colorCount * sizeof(Color) );
						gif->next = NULL;
						if (!gif->Colors) {
							free( gif->ImgBuf );
							gif->ImgBuf = NULL;
						}
						if (!gif->ImgBuf || !gif->Colors) {						// ̊mۂɎs
							memErr = -1;
							gif = NULL;
						}
					}
				} else {
					gif = NULL;
				}
				if (!gif) {														// pbg̈̎擾oĂȂȂ\gp
					gif = gifSub;
				}
				if (Col + Width > SWidth || Row + Height > SHeight) {
					strcpy( info, "RT-DecodeMode 摜͈͂Oʒuɍs悤w肳Ă" );
					ret = SUP_ERR;												// ͈͂摜TCY𒴂Ă
					err = -1;
					goto gif_Error;
				}
				if (GifFile->Image.Interlace) {									// C^[[X[h
					for (i = 0; i < 4; i++) {									/* Need to perform 4 passes on the images: */
						for (j = Row + InterlacedOffset[i]; j < Row + Height; j += InterlacedJumps[i]) {
							if (DGifGetLine(GifFile, &gif->ImgBuf[j*Width], Width) == GIF_ERROR) {
								gifErr = GifLastError();
								if (gifErr == D_GIF_ERR_EOF_TOO_SOON) {			// \Õ^C~OEOFɒB
									RecordType = TERMINATE_RECORD_TYPE;
									errEOF = 1;
									break;
								} else {										// EOFȊÕG[
									strcpy( info, "RT-DecodeMode Interlace DGifGetLine" );
									ret = LIB_ERR;
									err = -1;
									goto gif_Error;
								}
							}
						}
					}
				}
				else {															// ʏ惂[h
					for (i = 0; i < Height; i++) {
						if (DGifGetLine(GifFile, &gif->ImgBuf[i*Width], Width) == GIF_ERROR) {
							gifErr = GifLastError();
							if (gifErr == D_GIF_ERR_EOF_TOO_SOON) {				// \Õ^C~OEOFɒB
								RecordType = TERMINATE_RECORD_TYPE;
								errEOF = 1;
								break;
							} else {											// EOFȊÕG[
								strcpy( info, "RT-DecodeMode non-Interlace DGifGetLine" );
								ret = LIB_ERR;
								err = -1;
								goto gif_Error;
							}
						}
					}
				}
				corP = (unsigned char*)gif->Colors;
				for (i = 0; i < ColorMap->ColorCount; i++) {					// pbge[uۑ
					cp = ColorMap->Colors[i];
					*corP++ = cp.Red;
					*corP++ = cp.Green;
					*corP++ = cp.Blue;
					*corP++ = 0xFF;
				}
				gif->top = Row;
				gif->left = Col;
				gif->height = Height;
				gif->width = Width;												// ̈
				gif->transparent = transparent;
				gif->delaytime = delaytime;
				if (gif->delaytime < 50) gif->delaytime = 50;
				gif->ColorCount = colorCount;
				gif->ColorMap = cormap;
				img2pic( pv, *gif );											// pbgC[Wx^摜
				gVData.delaytime = gif->delaytime * 1000;

				drawTime = (clock() - drawClock) / 1000;
				frameTime = (clock() - frameClock) / 1000;
				frameClock = clock();
				sprintf( info, "A^CfR[h[h\nt@CTCY  %d[KB]\n"
				               "摜TCY  X=%d Y=%d\n̈  SX=%d SY=%d WX=%d WY=%d\n"
				               "J[  %d\nColorMap  %d\n摜  %d\nInterlace  %d\nfR[hG[F%s\n"
				               "Delay Time  %d[ms]\nImageCount  %d\nߐF  %d\n"
				               "t[^C  %d[ms]\nfR[h  %d[ms]",
				               (int)length/1024, SWidth, SHeight, Row, Col, Width, Height,
				               colorCount, cormap, imgCount, GifFile->Image.Interlace, errEOF ? gifErrMsg[22].msg : "",
				               delaytime, frameCnt, transparent,
				               frameTime, drawTime
				       );
				oldClock = clock();
				if (oldClock > clock()) oldClock = clock();						// NbNJEgI[o[t[ꍇ̑΍
				FreeMapObject( GifFile->Image.ColorMap );						// 
				GifFile->Image.ColorMap = NULL;									// [JJ[}bvɂ郁[N΍
				gifTmp = gif;
				frameCnt++;
				gVData.mode = 2;												// ʍ抮
				gVData.drawEnd = 1;												// 1ڂ̉摜fR[hI
				while (!gVData.nextFlag) {										// CXbhw܂őҋ@
					if (gVData.cancelFlag) break;
					sceKernelDelayThread( 500 );								// 0.5[ms]~
				}
				gVData.nextFlag = 0;
				if (frameCnt > 1) {
					gVData.anime = 1;											// Aj[V[h
				}
				break;
			case EXTENSION_RECORD_TYPE:											// ȗĂꍇ炵
				/* Skip any extension blocks in file: */
				if (DGifGetExtension( GifFile, &ExtCode, &Extension ) == GIF_ERROR) {
					strcpy( info, "RT-DecodeMode DGifGetExtension" );
					ret = LIB_ERR;
					err = -1;
					goto gif_Error;
				}
				if (ExtCode == GRAPHICS_EXT_FUNC_CODE) {
					int flag = Extension[1];
					transparent = (flag & 0x01) ? Extension[4] : -1;			// ߐFi-1:Ȃj
					delaytime = (Extension[2] + Extension[3] * 256) * 10;		// x
					if (delaytime > 60000) delaytime = 60000;					// lُȂ
				}
				while (Extension != NULL) {
					if (DGifGetExtensionNext(GifFile, &Extension) == GIF_ERROR) {
						strcpy( info, "RT-DecodeMode DGifGetExtensionNext" );
						ret = LIB_ERR;
						err = -1;
						goto gif_Error;
					}
				}
				break;
			case TERMINATE_RECORD_TYPE:
				break;
			default:
				break;
			}
		} while (RecordType != TERMINATE_RECORD_TYPE && !gVData.cancelFlag);
		imgCount = frameCnt;
		if (memErr) {											// LbV[hɈڍsoȂ̂ōă[vׂ̈̏
			DGifCloseFile(GifFile);
			gif_buf.data = (unsigned char*)data;
			gif_buf.length = length;
			gif_buf.offset = 0;
			if ((GifFile = DGifOpen(&gif_buf, gif_data_read_func)) == NULL) {
				strcpy( info, "RT-DecodeMode DGifOpen" );
				ret = LIB_ERR;
				err = -1;
			}
		} else if (imgCount == 1) {								// gif摜̏ꍇŃLbVɐĂȂ
			gVData.sdFlag = 1;									// keNX`̐
			sprintf( info, "LbV[h\nt@CTCY  %d[KB]\n"
			               "摜TCY  X=%d Y=%d\n̈  SX=%d SY=%d WX=%d WY=%d\n"
			               "J[  %d\nColorMap  %d\nInterlace  %d\nfR[hG[F%s\n"
			               "ߐF  %d\n"
			               "t[^C  %d[ms]\nfR[h  %d[ms]",
			               (int)length/1024, SWidth, SHeight, Row, Col, Width, Height,
			               colorCount, cormap, GifFile->Image.Interlace, errEOF ? gifErrMsg[22].msg : "",
			               transparent,
			               frameTime, drawTime
			       );
			break;
		}
	} while (!gExitRequest && !err && memErr && !gVData.cancelFlag);

gif_Error:
	DGifCloseFile(GifFile);

	//----- LbVꂽpbgC[Wŉʕ\s -----

	if (!gExitRequest && !err && !gVData.cancelFlag) {			// G[NĂȂȂ
		frameCnt = 0;
		gif = gifTop;
		if (imgCount > 1 && gif) {								// 摜ŃC[Wobt@mۂĂȂ
			frameClock = clock();
			do {												// 摜\[v
				drawClock = clock();
				img2pic( pv, *gif );							// pbgC[Wx^摜
				drawTime = (clock() - drawClock) / 1000;
				frameTime = (clock() - frameClock) / 1000;
				frameClock = clock();
				gVData.delaytime = gif->delaytime * 1000;
				sprintf( info, "LbV[hiAj[VGIFj\nt@CTCY  %d[KB]\n"
				               "摜TCY  X=%d Y=%d\n̈  SX=%d SY=%d WX=%d WY=%d\n"
				               "J[  %d\nColorMap  %d\n摜  %d\nInterlace  %d\nfR[hG[F%s\n"
				               "Delay Time  %d[ms]\nImageCount  %d\nߐF  %d\n"
				               "t[^C  %d[ms]\nC[WWJ  %d[ms]",
				               (int)length/1024, 
				               SWidth, SHeight, gif->left, gif->top, gif->width, gif->height,
				               gif->ColorCount, gif->ColorMap, imgCount, GifFile->Image.Interlace, errEOF ? gifErrMsg[22].msg : "",
				               gif->delaytime, frameCnt, gif->transparent,
				               frameTime, drawTime
				       );
				frameCnt++;
				gVData.mode = 2;											// ʍ抮
				while (!gVData.nextFlag) {						// CXbhw܂őҋ@
					if (gVData.cancelFlag) break;
					sceKernelDelayThread( 500 );				// 0.5[ms]~
				}
				gVData.nextFlag = 0;
				gif = gif->next;
				if (!gif) {										// ̃pbg񂪖
					frameCnt = 0;
					gif = gifTop;
				}
			} while (!gExitRequest && !gVData.cancelFlag);
		}
	} else {													// G[NĂ
		if (gifErr == 0) {
			gifErr = GifLastError();
		}
		if (gifErr != 0) {										// gif_libG[G[bZ[Wɕϊ
			char	msg[128];
			i = 0;
			while (gifErrMsg[i].id != 0) {
				if (gifErrMsg[i].id == gifErr) break;
				i++;
			};
			strcpy( msg, info );
			sprintf( info, "point : %s\nerror code : %d\n(%s)", msg, gifErr, gifErrMsg[i].msg );
		}
	}

	//----- I -----

gif_Error2:
	if (gifTop) {												// pbgJ
		gif = gifTop;
		do {													// `FCHȂ烁Ă
			free( gif->ImgBuf );
			free( gif->Colors );
			gifTmp = gif->next;
			free( gif );
			gif = gifTmp;
		} while (gif);											// NULL|C^Ɏ犮
	}
	if (gifSub) {												// ً}ppbg
		free( gifSub->ImgBuf );
		free( gifSub->Colors );
		free( gifSub );
	}
	return ret;
}


//==============================================================
// 摜fR[hXbh
//--------------------------------------------------------------
// t@CɃ[hA摜f[^fR[hB
// ̓TuXbhƂĎs܂B
//--------------------------------------------------------------

static int imageDecodeThread(SceSize args, void *argp)
{
	char		file[FILE_PATH];
	char		*image;											// 摜f[^
	int			ret, size, imgType;
	DirList		*DList;
	FileData	*FData;

	//----- ݒ -----

	gVData.info[0] = '\0';

	DList = *(DirList**)argp;
	FData = &DList->file[DList->pos];
	strcpy( file, gVData.path );
	strcat( file, "/" );
	strcat( file, FData->name2 );

	//----- t@C -----

	ret = 0;
	if (DList->archiveType == 0) {								// ʏtH_
		SceUID fd = sceIoOpen( file, PSP_O_RDONLY, FILE_PARMISSION );
		if (fd < 0) {
			ret = OPEN_ERR;
			sprintf( (char*)gVData.info, file );
			goto imageDecodeThread_error;
		}
		size = FData->size;
		image = (char*) malloc( sizeof(char) * (size + 1) );
		if (image) {
			sceIoRead( fd, image, size );
		}
		sceIoClose(fd);
		if (!image) {
			ret = MEM_ERR;
			sprintf( (char*)gVData.info, "%s\nTCY:%d", file, size );
			goto imageDecodeThread_error;
		}
	} else {													// ktH_
		image = expandToMem( file, DList, &size );				// A[JCuWJ
		if (image == NULL) {
			ret = EXPAND_ERR;
			goto imageDecodeThread_error;
		}
	}

	//----- fR[h -----

	imgType = checkExt( FData->name2 );
	switch (imgType) {
	case EXT_TYPE_JPG:
		ret = psp2chImageViewJpeg( image, size, &gVData.pv, gVData.info );
		break;
	case EXT_TYPE_PNG:
		ret = psp2chImageViewPng( image, size, &gVData.pv, gVData.info );
		break;
	case EXT_TYPE_GIF:
		ret = psp2chImageViewGif( image, size, &gVData.pv, gVData.info );
		break;
	case EXT_TYPE_BMP:
		ret = psp2chImageViewBmp( image, size, &gVData.pv, gVData.info );
		break;
	}
	free( image );												// 摜t@CĂȂȂ

imageDecodeThread_error:
	gVData.cancelFlag = 0;
	gVData.ret = ret;
	gVData.mode = 4;											// fR[hXbhI
	return 0;
}


//==============================================================
// TlCXg
//--------------------------------------------------------------

static void thumbListDraw(strVInfo *vinfo, DirList *DList)
{
	FileData	*FData, *FData2;
	int			i, x, y, hi, low, icon, count, pos, pos2;
	float		tw, th, alp, range, range2, range3;

	//------ ݒ -----

	FData = &DList->file[DList->pos];
	tw = THUMBXSIZE * 0.7;
	th = THUMBYSIZE * 0.7;
	if (FData->xSize==0 || gVData.mode==0) {					// [h̓TlC擾ĂȂ
		range2 = 999999;										// e␳𖳌
		range3 = 0;
	} else {													// TlCL
		if (FData->xSize / FData->ySize >= 1.78) {				// ʃTCYɍ킹邽߂̔{vZ
			range2 = FData->xSize / (float)SCREEN_WIDTH;
			range3 = vinfo->range * THUMBXSIZE / FData->xSize;
		} else {
			range2 = FData->ySize / (float)SCREEN_HEIGHT;
			range3 = vinfo->range * THUMBYSIZE / FData->ySize;
		}
		tw = tw * vinfo->range / range2;
		th = th * vinfo->range / range2;
	}

	//----- TlCXg -----

	pos = vinfo->nowFPos;
	pos2 = pos;
	for (i = 0; i < 7; i++) {									// 摜t@Č`FbN
		pos2 = nextImage( DList, pos2 );
		if (pos == pos2) {
			i += 3;
			break;
		}
	}
	count = i;
	pos2 = 0;													// TlCXgJnʒu
	for (i = 0; i < count/2; i++) {								// TlCXg̐擪ʒu擾
		if (s2ch.cfg.keySwap) {									// 摜L[̓ւ
			pos = nextImage( DList, pos );
		} else {
			pos = backImage( DList, pos );
		}
		pos2 -= THUMB_LIST_STEP;
	}
	for (i = 0; i < count; i++) {								// TlCXg\
		FData2 = &DList->file[pos];
		x = pos2 + i * THUMB_LIST_STEP + vinfo->nowX / (SCREEN_WIDTH / THUMB_LIST_STEP);
		hi = THUMB_LIST_STEP * ((count - 1) / 2 - 1);
		low = -THUMB_LIST_STEP * ((count / 2) - 1);
		if (abs(x) < THUMB_LIST_STEP / 2) {						// St
			alp = 0.7;
		} else if (x > low && x < hi) {							// TCh
			alp = 0.5;
		} else {												// ͈͊O
			if (x < 0) {
				alp = 0.5 * (THUMB_LIST_STEP - (low - x)) / THUMB_LIST_STEP;
			} else {
				alp = 0.5 * (THUMB_LIST_STEP - (x - hi)) / THUMB_LIST_STEP;
			}
			if (alp < 0) alp = 0;
		}
		if (abs(x) > THUMB_LIST_STEP) {							// Sɋ߂ÂقǑ傫Ȃ悤
			range = 0.5;
			x = SCREEN_WIDTH / 2 + ((x<0) ? -1 : 1) * THUMB_LIST_STEP * 0.2 + x;
		} else {
			range = 0.7 - 0.2 * abs(x) / THUMB_LIST_STEP;
			if (x == 0 && vinfo->range > range2) {
				range *= range2 / vinfo->range;					// ʃTCYȉɏkĂꍇ̕␳
			}
			x = SCREEN_WIDTH / 2 + x * (1 + 0.2);
		}
		if (FData2->thumb) {
			x -= FData2->thumb->wx * range / 2;
			y = SCREEN_HEIGHT - 27 - (FData2->thumb->wy * range) / 2;
			DrawPicAlpha( x, y, FData2->thumb, alp, range );
		} else {
			icon = getIconNo( FData2->name );
			x -= gIconImg[icon]->wx * range / 2;
			y = SCREEN_HEIGHT - 27 - ((gIconImg[icon]->wy - 24) * range) / 2;
			DrawPicAlpha( x, y, gIconImg[icon], alp, range );
		}
		if (s2ch.cfg.keySwap) {									// 摜L[̓ւ
			pos = backImage( DList, pos );
		} else {
			pos = nextImage( DList, pos );
		}
	}

	//----- ʔ͈ -----

	if (vinfo->range > range2) {								// ʃTCYȉɏkĂꍇ
		tw = THUMBXSIZE * 0.7;
		th = THUMBYSIZE * 0.7;
		x = -tw / 2;
		y = -th / 2;
	} else {
		x = -tw / 2 + vinfo->startX * 0.7 * range3;
		y = -th / 2 + vinfo->startY * 0.7 * range3;
	}
	x += SCREEN_WIDTH / 2;
	y += SCREEN_HEIGHT - 27;
	DrawBoxGu( x - 1, y - 1, tw + 0.5, th + 0.5, 0x000000, 0.3 );
	DrawBoxGu( x    , y    , tw + 0.5, th + 0.5, 0x000000, 0.1 );
	DrawBoxGu( x - 2, y - 2, tw + 0.5, th + 0.5, 0xFFFFFF, 0.7 );	// g
}

//==============================================================
// 摜\
//--------------------------------------------------------------
// path      摜t@ĈtH_
// DList     tH_̃t@C
// dFlag     wi摜XVꂽi0:No, 1:Yesj
//--------------------------------------------------------------
// w肳ꂽtH_̉摜\B
//--------------------------------------------------------------

int imageView(char *path, DirList *DList, int *dFlag)
{
	char			*p, msg[512], file[FILE_PATH], thumbPath[FILE_PATH], filename[FILE_PATH];
	int				ret, pos, modeBak, stepFlag, stepFlag2;
	int				nFlag, getThumbCountBak;
	FileData		*FData;
	unsigned int	viewTime, viewTime2;
	strVInfo		vinfo;

	const char	*guideMsg[] = { "+ : gk  + : X[WO\n : TCYύX  ~ : ߂   : KCh  kq : R}   : AĐ",
	                            "+ : gk  + : X[WO\n : TCYύX  ~ : ߂   : KCh  kq : 摜   : ꎞ~",
	                            "+ : gk  + : X[WO\n : TCYύX  ~ : ߂   : KCh  kq : 摜"
	                          };

	gLoadId = sceKernelCreateThread( "image_decode_thread", (SceKernelThreadEntry)&imageDecodeThread, 0x2E, 0x4000, 0, NULL );
	gVData.path = path;

	//----- 摜p[v -----

	gVData.cancelFlag = 0;										// Tu^XNfv
	gVData.pv.orgTex1.tex = NULL;
	gVData.pv.orgTex2.tex = NULL;								// Aj[VGIF̈\p
	gVData.pv.orgTex = &gVData.pv.orgTex1;
	gVData.pv.sdTex.tex = NULL;
	gVData.pv.sdThumb = 0;
	vinfo.menu = 1;												// KCh:On
	vinfo.pauseFlag = 0;
	vinfo.infoFlag = 0;
	vinfo.backFPos = -1;
	ret = 0;
	vinfo.nowX = 0;												// ʃXCȟ݈ʒu
	vinfo.targetX = 0;											// ʃXCh̖ڕWʒu
	vinfo.nowFPos = DList->pos;									// ʃXCḧړt@C
	vinfo.backImgDis = 0;										// ʃXCh̎擾wi摜͖i0:Lj
	vinfo.filter = 0;											// 摜ɃX[WOsi0:j
	nFlag = 0;													// Aj[V̉ʍXV^C~OǗ
	while (!gExitRequest) {										// 摜p[v
		gVData.info[0] = '\0';
		gVData.mode = 0;										// obNXbh̏
		gVData.aniPage = 0;										// Aj[V̓WJeNX`I
		gVData.drawEnd = 0;										// 1ڂ̉摜fR[hI
		gVData.sdFlag = 1;										// keNX`̐
		vinfo.FPos = DList->pos;								// wi摜擾̃t@Cʒuʒmp
		modeBak = gVData.mode;
		if (sceKernelStartThread( gLoadId, sizeof(DirList**), (void*)&DList )) {
			MessageDialogText( "fR[hXbh̋NɎs܂" );
			break;
		}
		FData = &DList->file[DList->pos];
		if_clipText( filename, FData->name, 460, 0.7f );
		strcpy( file, path );
		strcat( file, "/" );
		strcat( file, FData->name2 );
		p = strchr( file, ':' );
		if (p) {												// hCu^[Ȃ
			pos = p - file + 1;
			strncpy( thumbPath, file, pos );
			thumbPath[pos] = '/';
			thumbPath[pos+1] = '\0';
			strcat( thumbPath, THUMBFOLDER );					// TlCtH_
			strcat( thumbPath, &file[pos] );
			strcat( thumbPath, ".dat" );						// TlCۑĂnỸtH_
		} else {												// hCu^[Ȃi肦Ȃ͂j
			thumbPath[0] = '\0';
		}
		vinfo.thumb = FData->thumb;								// TlC
		if (!vinfo.thumb) {										// TlĈŃftHgACRZbg
			vinfo.thumb = gIconImg[getIconNo( FData->name2 )];
		}

		//----- \C -----

		ret = 10;
		vinfo.sizeMode = -1;									// 摜TCY͉ʂɎ߂
		vinfo.sizeModeSwap = 0;									// 摜TCY̑JڂύX邩
		vinfo.reset = 1;
		vinfo.viewTime = 0;
		vinfo.viewFlag = 0;
		gVData.anime = 0;
		gVData.nextFlag = 0;
		gVData.ret = 0;
		stepFlag = 0;											// GIF|[ỸR}w
		stepFlag2 = 0;											// GIF|[ỸR}ʍXVw
		viewTime = clock();										// 摜؂ւ^C~OJEgp
		getThumbCountBak = gGetThumbCount;
		while (ret==10 && !gExitRequest) {
			if (gDialogFlag) {									// Tu^XNŃ_CAO\Ă
				sceDisplayWaitVblankStart();
				continue;
			}
			viewTime2 = clock();								// 揈ԃJEg

			if (statusDraw2(1)) {								// ω
				vinfo.drawFlag = 1;								// ʂXV
			}

			if (gGetThumbCount != getThumbCountBak) {			// TlC̎擾ω
				getThumbCountBak = gGetThumbCount;
				vinfo.drawFlag = 1;								// ʂXV
			}


			if (abs(vinfo.nowX - vinfo.targetX) < 10) {			// ʃXCh
				if (vinfo.nowX != 0) {							// ڕWʒuB
					vinfo.drawFlag = 1;							// ʂXV
					vinfo.backImgDis = 1;						// 擾wi摜͖
				}
				vinfo.targetX = 0;
				vinfo.nowX = 0;
				vinfo.nowFPos = DList->pos;
			} else {
				vinfo.nowX += (vinfo.targetX - vinfo.nowX) / 4;
				if (vinfo.nowX <= -480) {
					vinfo.nowX += 480;
					vinfo.targetX += 480;
					vinfo.nowFPos = backImage( DList, vinfo.nowFPos );
				} else if (vinfo.nowX >= 480) {
					vinfo.nowX -= 480;
					vinfo.targetX -= 480;
					vinfo.nowFPos = nextImage( DList, vinfo.nowFPos );
				}
				vinfo.drawFlag = 1;								// ʂXV
			}

			switch (gVData.mode) {								// 惂[hؑ
			case 0:												// [h
				if (vinfo.drawFlag || viewTime + 500000 < clock() || viewTime > clock()) {
					viewTime = clock();
					guStart();
					sceGuClearColor( s2ch.BakCor );
					sceGuClearDepth( 0 );
					sceGuClear( GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT );
					imageDraw( NULL, &vinfo, DList );			// 摜\
					vinfo.viewFlag = 1;
				}
				if (sceCtrlPeekBufferPositive( &s2ch.pad, 1 )) {
					if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
						s2ch.oldPad = s2ch.pad;
						if (s2ch.pad.Buttons & PSP_CTRL_CROSS) {
							ret = COMPLETE;						// LZ
						} else if (s2ch.pad.Buttons & PSP_CTRL_RTRIGGER ) {
							ret = SHIFT;						// ʃXCh
						} else if (s2ch.pad.Buttons & PSP_CTRL_LTRIGGER ) {
							ret = SHIFT;						// ʃXCh
						}
					}
				}
				break;

			case 1:												// GIFAj[VfR[h
				ret = image2screen( &gVData.pv, &vinfo, DList, thumbPath);
				if (ret==11 || ret==12) {						// R}
					stepFlag = 1;
					ret = 10;
				}
				if (ret != 10) {
					gVData.cancelFlag = 1;
				}
				break;
			case 2:												// GIFҋ@
				if (stepFlag || (!vinfo.pauseFlag && (viewTime + gVData.delaytime < clock() || viewTime > clock()))) {
					stepFlag = 0;
					stepFlag2 = 1;
					viewTime = clock();
					gVData.mode = 1;
					vinfo.drawFlag = 1;							// ʂXV
					ret = image2screen( &gVData.pv, &vinfo, DList, thumbPath);
					nFlag = 1;
				} else {
					if (stepFlag2) {
						stepFlag2 = 0;
						vinfo.drawFlag = 1;						// ʂXV
					}
					ret = image2screen( &gVData.pv, &vinfo, DList, thumbPath);
				}
				if (ret==11 || ret==12) {						// R}
					stepFlag = 1;
					ret = 10;
				}
				if (ret != 10) {
					gVData.cancelFlag = 1;
				}
				break;

			case 3:												// Î~fR[h
				if (viewTime + 500000 < clock() || viewTime > clock()) {
					viewTime = clock();
					vinfo.drawFlag = 1;							// 0.5[s]ɉʂXV
					vinfo.sdDrawFlag = 1;						// keNX`XV
				}
				ret = image2screen( &gVData.pv, &vinfo, DList, thumbPath);
				if (ret != 10) {
					gVData.cancelFlag = 1;
				}
				break;
			case 4:												// fR[hXbhIiÎ~\[hj
				if (modeBak == 3) {								// fR[hȂeNX`XV
					vinfo.drawFlag = 1;
					vinfo.sdDrawFlag = 1;						// keNX`XV
				}
				if (gVData.ret < 0) {							// G[Ă
					ret = gVData.ret;
					vinfo.viewFlag = 0;
					break;
				} else {
					ret = image2screen( &gVData.pv, &vinfo, DList, thumbPath);
				}
				break;
			}
			modeBak = gVData.mode;

			if (vinfo.viewFlag) {								// e̕\
				vinfo.viewFlag = 0;
				if (vinfo.menu == 1) {							// KCh
					int		mode;
					if_clipText( msg, FData->name2, 340, 0.7f );
					if_printSjis( 5, 16, msg, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
					statusDraw2( 0 );							// \
					if (gVData.anime == 0) {					// Î~惂[h
						mode = 2;
					} else {									// Aj[V[h
						if (vinfo.pauseFlag) {					// R}胂[h
							mode = 0;
						} else {								// AĐ[h
							mode = 1;
						}
					}
					if_printSjis( 10, 250, (char*)guideMsg[mode], 0.8f, 0xFFFFFF, 0x101010, 0.7f );

				} else if (vinfo.menu == 2) {					// TlCXg\
					if_clipText( msg, FData->name2, 340, 0.7f );
					if_printSjis( 5, 16, msg, 0.7f, 0xFFFFFF, 0x101010, 0.7f );
					statusDraw2( 0 );							// \
					thumbListDraw( &vinfo, DList );				// TlCXg̍
				}

				if (vinfo.infoFlag) {							// 摜\
					char	*str, msg[512], buf[128];
					strcpy( msg, (char*)gVData.info );
					sprintf( buf, "\n掞  %d[ms]\n{  %d[%%]",
					              vinfo.viewTime/1000, (int)(100/vinfo.range)
					       );
					strcat( msg, buf );
					if (gVData.pv.sdTex.tex) {					// keNX`Ȃ
						sprintf( buf, "\nkeNX`  k:%d :%d [TCY:%d",
						              gVData.pv.sdThumb, gVData.pv.sdTex.count, gVData.pv.sdTex.widthAlign
						       );
						strcat( msg, buf );
					}
					str = msg;
					if_printSjis( 10, 40, str, 0.7f, 0xFFFFFF, 0x101010, 1.0f );
				}
				sceGuFinish();
				sceGuSync( 0, 0 );
				if (nFlag) {
					nFlag = 0;
					gVData.nextFlag = 1;						// Aj[ṼfR[hJn^C~O
				}
				vinfo.viewTime = clock() - viewTime2;
				sceDisplayWaitVblankStart();
				flipScreen(0);
			} else {
				sceDisplayWaitVblankStart();
			}
		}

		if (gVData.mode != 4) {									// 摜fR[hXbhNĂ
			gVData.cancelFlag = 1;								// 摜fR[hXbhIv
			while (gVData.cancelFlag) {							// 摜fR[hXbhI܂őҋ@
				sceDisplayWaitVblankStart();
			}
		}
		gVData.anime = 0;
		gVData.nextFlag = 0;
		freeTexMem( &gVData.pv );								// eNX`̉
		if (ret == COMPLETE || ret == SHIFT) {
			*dFlag = 1;											// wi摜ω
		}
		//----- 摜 -----

		if (ret == SHIFT ) {									// 摜
			int		chKey;
			if (s2ch.cfg.keySwap) {								// 摜L[̓ւ
				chKey = PSP_CTRL_LTRIGGER;
			} else {
				chKey = PSP_CTRL_RTRIGGER;
			}
			if (vinfo.nowX == 0) {
				vinfo.nowFPos = DList->pos;						// ʃXCḧړt@C
			}
			if (s2ch.pad.Buttons & chKey) {						// ̉摜
				DList->pos = nextImage( DList, DList->pos );
				vinfo.targetX += 480;
			} else {											// Ỏ摜
				DList->pos = backImage( DList, DList->pos );
				vinfo.targetX -= 480;
			}
			if (vinfo.targetX == 0) {							// ɖ߂ꍇ
				vinfo.backImgDis = 1;							// ʃXCh̎擾wi摜͖
			}
		} else {
			break;												// 摜Ƃ͊֌WȂ̂Ń[vI
		}
	}

	//----- I -----

	if (vinfo.backFPos == -1) {									// wi摜擾t@Cʒu
		*dFlag = 0;
	} else {
		*dFlag = 1;
	}
	if (ret < 0) {
		msg[0] = '\0';
		switch (ret){
		case LIB_ERR:
			strcpy( msg, "摜tH[}bgsł\n\n" );
			break;
		case MEM_ERR:
			strcpy( msg, "mۂł܂ł\n\n" );
			break;
		case SUP_ERR:
			strcpy( msg, "T|[gĂȂ摜`ł\n\n" );
			break;
		case FRM_ERR:
			strcpy( msg, "摜܂\n\n" );
			break;
		case OPEN_ERR:
			strcpy( msg, "t@CJ܂\n\n" );
			break;
		case EXPAND_ERR:
//			strcpy( msg, "A[JCu̓WJɎs܂\n\n" );
			break;
		case TEST_ERR:
			strcpy( msg, "eXg|Cg\n\n" );
			break;
		}
		if (msg[0] != '\0') {
			strcat( msg, (char*)gVData.info );
			MessageDialogText( msg );
		}
	}
	sceKernelDeleteThread( gLoadId );
	return ret;
}
