#ifndef _RAR_ERRHANDLER_
#define _RAR_ERRHANDLER_

#define rarmalloc malloc
#define rarcalloc calloc
#define rarrealloc realloc
#define rarfree free
#define rarstrdup strdup

enum { SUCCESS,WARNING,FATAL_ERROR,CRC_ERROR,LOCK_ERROR,WRITE_ERROR,
       OPEN_ERROR,USER_ERROR,MEMORY_ERROR,CREATE_ERROR,USER_BREAK=255};

class ErrorHandler
{
  private:
    int ExitCode;
  public:
    ErrorHandler();
    void Clean();
    void MemoryError();
    void CloseError(const char *FileName);
    void ReadError(const char *FileName);
    void SeekError(const char *FileName);
    void Exit(int ExitCode);
    void SetErrorCode(int Code);
    void Throw(int Code);
};

#endif
