//==============================================================
// FVunzip.c
//
// miniunz.c Copyright (C) 1998-2004 Gilles Vollant
// 2010-2011 STEAR  freeze viewerpɂȂC܂
//--------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>
#include <malloc.h>
#include <pspiofilemgr.h>
#include <pspdisplay.h>
#include <pspdebug.h>
#include <pspctrl.h>

#include "FreezeViewer.h"
#include "fileList.h"
#include "fvTool.h"
#include "charConv.h"
#include "unzip.h"

#define CASESENSITIVITY (0)
#define WRITEBUFFERSIZE (64 * 1024)								// WJɎgpő僁
#define MAXFILENAME (256)

extern S_2CH		s2ch;										// fvTool.c


//==============================================================
// change the date/time of a file
//--------------------------------------------------------------
// filename : the filename of the file where date/time must be modified
// tmu_date : the SAME new date at the tm_unz format
//--------------------------------------------------------------

static void change_file_date(const char *filename, tm_unz tmu_date)
{
	SceIoStat		st;
	ScePspDateTime	st_time;

	memset(&st, 0, sizeof(st));
	st.st_mode = 0777;
	st.st_attr = FIO_SO_IFREG;
	st_time.microsecond = 0;
	st_time.second      = tmu_date.tm_sec;
	st_time.minute      = tmu_date.tm_min;
	st_time.hour        = tmu_date.tm_hour;
	st_time.day         = tmu_date.tm_mday;
	st_time.month       = tmu_date.tm_mon + 1;
	st_time.year        = tmu_date.tm_year;
	st.st_ctime = st_time;
	st.st_atime = st_time;
	st.st_mtime = st_time;
	sceIoChstat( filename, &st, FIO_S_IRWXU | FIO_S_IRWXG | FIO_S_IRWXO );
}

//==============================================================
// tH_
//--------------------------------------------------------------
// itH_xɐ܂B
//--------------------------------------------------------------

static int mymkdir(char *dirname)
{
	return sceIoMkdir( dirname, 0777 );
}

int makedir(char *newdir)
{
	char *buffer;
	char *p;
	int  len = (int)strlen(newdir);

	if (len <= 0) return 0;

	buffer = (char*) malloc(len+1);
	strcpy( buffer, newdir );

	if (buffer[len-1] == '/') {
		buffer[len-1] = '\0';
	}
	if (mymkdir(buffer) == 0) {
		free(buffer);
		return 1;
	}

	p = buffer+1;
	while (1) {
		char hold;

		while(*p && *p != '\\' && *p != '/') {
			p++;
		}
		hold = *p;
		*p = 0;
		if ((mymkdir(buffer) == -1) && (errno == ENOENT)) {
			free(buffer);
			return 0;
		}
		if (hold == 0) break;
		*p++ = hold;
	}
	free(buffer);
	return 1;
}

//==============================================================
// t@CWJ
//--------------------------------------------------------------
// uf                       Fzipt@C
// popt_extract_without_pathF0    pXČ
//                            ȊO pX\͖
// destName                 FWJ̃t@Cw
// password                 FpX[h
// work                     F[֓WJꍇ̊i[|C^
// info                     FG[̃O
//--------------------------------------------------------------
// workNULLȂt@CƂēWJB
// workɃ|C^w肳ĂȂ烁mۂĂɓWJB
//--------------------------------------------------------------

static int do_extract_currentfile(uf, popt_extract_without_path, destName, password, work, info)
	unzFile		uf;
	const int	popt_extract_without_path;
	const char	*destName;
	const char	*password;
	char		**work;
	char		*info;
{
	char			filename_inzip[1024], filename_inzip_sjis[1024];
	char			*filename_withoutpath, *write_filename;
	char			*p, *workbuf = NULL;
	int				i, err = UNZ_OK, skip = 0;
	SceUID			fout;
	u8				*buf;
	uInt			size_buf, pos = 0;
	unz_file_info	file_info;

	err = unzGetCurrentFileInfo( uf, &file_info, filename_inzip, sizeof(filename_inzip), NULL, 0, NULL, 0 );
	if (err != UNZ_OK) {
		sprintf( info, "%s\nzipt@C̏񂪎擾ł܂ł\nizipt@CĂHj", filename_inzip );
		return err;
	}
	DoEvent();													// ̃Xbh𓮂

	strcpy( filename_inzip_sjis, filename_inzip );				// ʕ\p
	if (s2ch.cfg.hbl){											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSjis2UTF8( filename_inzip, filename_inzip );
	}

	size_buf = WRITEBUFFERSIZE;
	for (i=0; i<4; i++) {										// WRITEBUFFERSIZE`͈̔͂ŏo邾傫ȍƈmۂ
		buf = (void*) malloc(size_buf);
		if (buf) break;											// mۂł烋[vI
		size_buf = size_buf >> 1;
	}
	if (buf == NULL) {											// ǃmۂoȂ
		sprintf( info, "zipWJƗp̎擾Ɏs܂" );
		return UNZ_INTERNALERROR;
	}
	if (work != NULL) {
		workbuf = (char*) malloc(file_info.uncompressed_size+1);
		if (workbuf == NULL) {
			free(buf);
			sprintf( info, "zipWJƗp̎擾Ɏs܂" );
			return UNZ_INTERNALERROR;
		}
		*work = workbuf;
	}

	p = filename_withoutpath = filename_inzip;
	while ((*p) != '\0') {										// pX̍Ō'/''\'T
		if (((*p)=='/') || ((*p)=='\\'))
			filename_withoutpath = p+1;
		p++;
	}
	if ((*filename_withoutpath) == '\0') {						// pX'/''\'ŏIĂȂ
		if (popt_extract_without_path == 0) {
			mymkdir(filename_inzip);							// tH_
		}
	} else {													// t@CWJ
		if (destName == NULL) {
			if (popt_extract_without_path == 0) {
				write_filename = filename_inzip;				// pXtt@C
			} else {
				write_filename = filename_withoutpath;			// t@Ĉ
			}
		} else {
			write_filename = (char*) destName;					// t@C̋w
		}

		if (strlen(password) != 0) {
			err = unzOpenCurrentFilePassword( uf, password );
		} else {
			err = unzOpenCurrentFilePassword( uf, NULL );
		}
		if (err != UNZ_OK){
			sprintf( info, "%s\nWJɎs܂\nizipt@CĂHj", filename_inzip_sjis );
		}

		if ((work==NULL) && (skip==0) && (err==UNZ_OK)) {		// fBNg\\z
			fout = sceIoOpen( write_filename, O_RDWR, 0777 );
			/* some zipfile don't contain directory alone before file */
			if ((fout<=0) && popt_extract_without_path==0 &&
			                    (filename_withoutpath!=(char*)filename_inzip))
			{
				char c = *(filename_withoutpath-1);
				*(filename_withoutpath-1) = '\0';
				makedir(write_filename);
				*(filename_withoutpath-1) = c;
				fout = sceIoOpen( write_filename, O_RDWR, 0777 );
			}
			sceIoClose(fout);
		}

		if (work == NULL) {										// t@C֓WJ
			fout = sceIoOpen( write_filename, O_RDWR | O_CREAT, 0777 );
			if (fout > 0) {
				do {											// Jgt@CWJۑ
					err = unzReadCurrentFile( uf, buf, size_buf );
					if (err < 0) {
						sprintf( info, "t@C̓WJɎs܂\nipX[hԈĂHj" );
						break;
					}
					DoEvent();									// ̃Xbh𓮂
					if (err > 0) {
						if (sceIoWrite(fout,buf,err) != err) {
							sprintf( info, "%s\nt@Cւ݂̏Ɏs܂\nifBXNeʂȂHj", filename_inzip_sjis );
							err = UNZ_ERRNO;
							break;
						}
					}
					DoEvent();									// ̃Xbh𓮂
				} while (err > 0);
				sceIoClose(fout);
				if (err == 0) {									// WJIt@C
					change_file_date( write_filename, file_info.tmu_date );
				}
			} else {
				sprintf( info, "%s\nt@C̍쐬Ɏs܂", write_filename );
			}

		} else {												// ֓WJ
			pos = 0;
			do {												// Jgt@CWJۑ
				err = unzReadCurrentFile( uf, buf, size_buf );
				if (err < 0) {
					sprintf( info, "t@C̓WJɎs܂\nipX[hԈĂHj\nError:%d", err );
					break;
				}
				DoEvent();										// ̃Xbh𓮂
				if (err > 0) {
					if (pos+err > file_info.uncompressed_size) {	// mۂobt@zȂ
						err = file_info.uncompressed_size - pos;
						memcpy( &workbuf[pos], buf, err );
						err = 0;
						break;
					}
					memcpy( &workbuf[pos], buf, err );
					pos += err;
				}
			} while (err > 0);
		}

		if (err == UNZ_OK) {
			err = unzCloseCurrentFile(uf);
			if (err != UNZ_OK) {								// CRC Error\
				sprintf( info, "%s is CRC Error\nizipt@CĂcHj", filename_inzip_sjis );
			}
		} else {
			unzCloseCurrentFile(uf);		/* don't lose the error */
		}
    }

	if (err!=UNZ_OK && work!=NULL) {
		free(*work);
		*work = NULL;
	}
	if (err==UNZ_OK && work!=NULL) {							// WJ̓TCYԂ
		err = pos;
	}
	free(buf);
	return err;
}

//==============================================================
// A[JCuɊ܂܂SẴt@CWJ
//--------------------------------------------------------------

static int do_extract(uf, password, info)
	unzFile		uf;
	const char*	password;
	char		*info;
{
	uLong			i;
	unz_global_info	gi;
	int				err;

	err = unzGetGlobalInfo( uf, &gi );
	if (err != UNZ_OK) {
		sprintf( info, "zipt@C擾ł܂ł" );
		return err;
	}

	gFCdata.progMax = gi.number_entry;							// vOXo[ݒ
	gFCdata.progPos = 0;
	for (i=0; i<gi.number_entry; i++) {
		gFCdata.progPos++;
		err = do_extract_currentfile( uf, 0, NULL, password, NULL, info );
		if (err != UNZ_OK) break;
		if (gFileCtrlEnd) break;								// fv

		if ((i+1) < gi.number_entry) {
			err = unzGoToNextFile(uf);
			if (err != UNZ_OK) {
				sprintf( info, "WJrŃG[܂\nzipt@CĂH" );
				break;
			}
		}
	}

	return err;
}

//==============================================================
// w肳ꂽ̃t@Ĉ݂WJ
//--------------------------------------------------------------
// zippath Fzipt@Cւ̃tpX
// inpath  Fzipt@C̃t@Cւ̃pX
// destpathFWJtH_
// destnameFWJɃt@Cw
// pass    FpX[h
// info    FG[bZ[W
// ߂l  F0     I
//           0ȉ G[
//--------------------------------------------------------------
// destpathtH_zippathA[JCũt@CWJB
//--------------------------------------------------------------

int unzipToFile(const char *zippath, const char *inpath, const char *destpath, const char *destname, const char *pass, char *info)
{
	unzFile	uf;
	char	folder[1024], dirname[1024];
	int		ret;

	getcwd( folder, 1024 );										// JgfBNg擾
	strcpy( dirname, destpath );

	if (zippath == NULL) {
		sprintf( info, "A[JCuJƂo܂ł" );
		return -1;
	}
	uf = unzOpen(zippath);
	if (uf == NULL) {
		sprintf( info, "%s\nA[JCuƂĊJƂo܂ł", zippath );
		return -1;
	}

	if (unzLocateFile(uf,inpath,CASESENSITIVITY) != UNZ_OK) {
		sprintf( info, "%s\n%s\nw肳ꂽt@C܂", zippath, inpath );
		return -1;
	}

	if (s2ch.cfg.hbl) {											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSjis2UTF8( dirname, dirname );
	}
	if (chdir(dirname)) {										// WJtH_Ɉړ
		sprintf( info, "%s\nwtH_܂", dirname );
		unzClose(uf);
		return UNZ_INTERNALERROR;
	}
	ret = do_extract_currentfile( uf, 1, destname, pass, NULL, info );

	unzClose(uf);
	chdir(folder);												// JgfBNgɖ߂
	return ret;
}

//==============================================================
// w肳ꂽ̃t@C֓WJ
//--------------------------------------------------------------
// zippath Fzipt@Cւ̃tpX
// inpath  Fzipt@C̃t@Cւ̃pX
// work    FWJ|C^
// pass    FpX[h
// info    FG[bZ[W
// ߂l  F0`  :IiWJf[^̃TCYj
//           0ȉ:G[
//--------------------------------------------------------------
// work|C^zippathA[JCuinpatht@CWJf[^ԂB
// G[ꍇwork͖B
// work̃TCY͕Kve+1mۂĂ܂B
//--------------------------------------------------------------

int unzipToMemory(const char *zippath, const char *inpath, char **work, const char *pass, char *info)
{
	unzFile	uf;
	int		ret;

	uf = NULL;
	if (zippath != NULL) {
		uf = unzOpen(zippath);
	}
	if (uf == NULL) {
		if (zippath == NULL) {
			sprintf( info, "A[JCuJƂo܂ł" );
		} else {
			sprintf( info, "%s\nA[JCuƂĊJƂo܂ł", zippath );
		}
		return -1;
	}

	if (unzLocateFile(uf,inpath,CASESENSITIVITY) != UNZ_OK) {
		sprintf( info, "%s\n%s\nw肳ꂽt@C܂", zippath, inpath );
		return -1;
	}
	ret = do_extract_currentfile( uf, 1, NULL, pass, work, info );

	unzClose(uf);
	return ret;
}

//==============================================================
// zipt@CWJ
//--------------------------------------------------------------
// zippath Fzipt@Cւ̃tpX
// destpathFWJtH_
// pass    FpX[h
// info    FG[bZ[W
// ߂l  F0     I
//           0ȉ G[idestpathtH_ɈꕔWJĂj
//--------------------------------------------------------------
// destpathtH_zippathA[JCuWJB
//--------------------------------------------------------------

int unzipToDir(const char *zippath, const char *destpath, const char *pass, char *info)
{
	const char	*zipfilename = NULL;
	char		folder[1024], dirname[1024];
	int			ret;
    unzFile		uf = NULL;

	getcwd( folder, 1024 );										// JgfBNg擾

	zipfilename = zippath;			//"ms0:/testzip.zip";
	strcpy( dirname, destpath );	//"ms0:/zext/";

	if (zipfilename != NULL) {
		uf = unzOpen(zipfilename);
	}

	if (uf == NULL) {
		if (zipfilename == NULL) {
			sprintf( info, "A[JCuJƂo܂ł" );
		} else {
			sprintf( info, "%s\nA[JCuƂĊJƂo܂ł", zipfilename );
		}
		return -1;
	}

	if (s2ch.cfg.hbl) {											// HBLł̓t@C̃VtgJISUTF8ϊs
		psp2chSjis2UTF8( dirname, dirname );
	}
	if (chdir(dirname)) {										// WJtH_Ɉړ
		sprintf( info, "%s\nwtH_܂", dirname );
		unzClose(uf);
		return UNZ_INTERNALERROR;
	}
	ret = do_extract( uf, pass, info );

	unzClose(uf);
	chdir(folder);												// JgfBNgɖ߂
	return ret;
}


//==============================================================
// zipt@C`FbN
//--------------------------------------------------------------
// zippathFzipt@Cւ̃tpX
// ߂lF-1:zipt@CJȂizipt@Cł͂ȂHj
//          0:zipt@Cwb_mF
//--------------------------------------------------------------
// wt@Czipt@CƂĊJ邩𒲂ׂB
//--------------------------------------------------------------

int unzipCheck(const char *zippath)
{
	unzFile			uf;
	unz_global_info	gi;
	int				err;

	uf = unzOpen(zippath);
	if (uf == NULL) return -1;
	err = unzGetGlobalInfo(uf, &gi);
	unzClose(uf);
	if (err != UNZ_OK) return -1;
	return 0;
}


//==============================================================
// zipt@C̃pX[h`FbN
//--------------------------------------------------------------
// zippathFzipt@Cւ̃tpX
// pass   FpX[h
// ߂lF-1:zipt@CJȂizipt@Cł͂ȂHj
//          0:pX[hv
//          1:pX[h͕sv
//--------------------------------------------------------------
// w肳ꂽzipt@CwpX[hœWJł邩𒲂ׂB
//--------------------------------------------------------------

int unzipPass(const char *zippath, const char *pass)
{
	unzFile			uf;
	unz_file_info	file_info;
	unz_global_info	gi;
	char	filename_inzip[1024], buf[1024];
	int		i, ret, err, len;

	uf = unzOpen(zippath);
	if (uf == NULL) return -1;
	err = unzGetGlobalInfo(uf, &gi);
	if (err != UNZ_OK) {
		unzClose(uf);
		return -1;
	}

	ret = 0;
	for (i=0; i<gi.number_entry; i++) {							// ŏ̃t@CT
		ret = unzGetCurrentFileInfo(uf, &file_info, filename_inzip, sizeof(filename_inzip), NULL, 0, NULL, 0);
		if (ret == UNZ_OK) {
			len = strlen(filename_inzip);
			if (filename_inzip[len-1]!='/' && filename_inzip[len-1]!='\\') {
				if (strlen(pass) == 0) {
					err = unzOpenCurrentFilePassword( uf, NULL );
				} else {
					err = unzOpenCurrentFilePassword( uf, pass );
				}
				if (err != UNZ_OK) {
					ret = -1;
					break;
				}
				err = unzReadCurrentFile( uf, buf, sizeof(buf) );
				if (err == -3) {								// w肳ꂽpX[hœWJĂ݂ăG[ɂȂ
					ret = 1;									// ̃pX[h͎gȂ
				}
				unzCloseCurrentFile(uf);
				break;
			}
		}
		ret = unzGoToNextFile(uf);
		if (ret != UNZ_OK) {
			ret = -1;
			break;
		}
	}

	unzClose(uf);
	return ret;
}

//==============================================================
// zipt@CGg̎擾
//--------------------------------------------------------------
// DList FXg\
// path  Fzipt@Cւ̃tpX
// inPathFzipt@C̎擾fBNg
// ߂lFNULL:G[
//         ȊO:t@Cւ̃|C^
//--------------------------------------------------------------
// w肳ꂽzipt@C̎wpXɂGg擾B
// pX̃Zp[^'\'gĂzipt@C͐ɈȂB
//
// zipt@C̃fBNg\͌XɃtpXŋLqȀԂ
// zipt@CɃGgǉꂽԂŕłB܂oo
// ̏Ԃw肳ꂽfBNgȉ̃Gg擾ꍇ
// SGg̃pX𑖍KvB
//--------------------------------------------------------------

//===== t@C̃Ro[g =====

static void setFileInfo(ScePspDateTime *st, unz_file_info file_info)
{
	st->microsecond = 0;
	st->second      = file_info.tmu_date.tm_sec;
	st->minute      = file_info.tmu_date.tm_min;
	st->hour        = file_info.tmu_date.tm_hour;
	st->day         = file_info.tmu_date.tm_mday;
	st->month       = file_info.tmu_date.tm_mon + 1;
	st->year        = file_info.tmu_date.tm_year;
}

//===== zipt@CGg̎擾 =====

FileData *unzipGetEntry(DirList *DList, char *path, char *inPath)
{
	unzFile			uf;
	unz_global_info	gi;
	unz_file_info	file_info;
	FileData		*FData;
	char	*p1, *p2, *buf, filename_inzip[1024], utf8[1536];
	int		i, err, count;

	uf = unzOpen(path);
	if (uf == NULL) {
		return NULL;
	}
	err = unzGetGlobalInfo(uf, &gi);
	if (err != UNZ_OK) {
		unzClose(uf);
		return NULL;
	}

	FData = (FileData*) malloc(sizeof(FileData) * gi.number_entry);
	if (FData == NULL) {
		unzClose(uf);
		return NULL;
	}
	count = 0;
	while (count < gi.number_entry) {
		if (gGetDirEnd[DList->getDirMode]) {					// f
			break;
		}
		err = unzGetCurrentFileInfo(uf, &file_info, filename_inzip, sizeof(filename_inzip), NULL, 0, NULL, 0);
		if (err == UNZ_OK) {
			if (strlen(inPath)==0 ||
			        (memcmp(filename_inzip,inPath,strlen(inPath)) == 0 &&
			         filename_inzip[strlen(inPath)] == '/') ) {
				if (strlen(inPath) == 0) {						// [g̏ꍇ
					p1 = filename_inzip;
				} else {										// TufBNg̏ꍇ
					if (strlen(filename_inzip) <= strlen(inPath) + 1 + 1) {
						p1 = "";								// Gĝ
					} else {
						p1 = &filename_inzip[strlen(inPath) + 1];
					}
				}
				FData[count].type = 0;
				err = 0;
				p2 = strchr( p1, '/' );
				if (p2) {										// TufBNgĂꍇ
					FData[count].type = 1;
					*p2 = '\0';
					for (i=0; i<count; i++) {					// o^ς݃fBNgH
						if (FData[i].type != 0 && strcmp(FData[i].name2,p1) == 0) {
							err = 1;							// o^ς݂
							break;
						}
					}
				}
				if (err == 0 && strlen(p1) != 0) {				// Ggo^
					buf = (char*) malloc( strlen(p1) + 1 );
					if (buf != NULL) {
						strcpy( buf, p1 );
						FData[count].name2 = buf;				// VtgJIS
						psp2chSjis2UTF8( utf8, p1 );
						buf = (char*) malloc( strlen(utf8) + 1 );
						if (buf == NULL) {						// ȂI
							free( FData[count].name2 );
							FData[count].name2 = NULL;
						} else {								// Ggo^
							strcpy( buf, utf8 );
							FData[count].name = buf;			// UTF8
							FData[count].size = file_info.uncompressed_size;
							setFileInfo( &FData[count].mtime, file_info );
							FData[count].thumb = NULL;
							FData[count].xSize = 0;				// 摜XTCY (0:擾ĂȂ)
							FData[count].ySize = 0;				// 摜YTCY
							FData[count].msg = NULL;
							FData[count].settingMsg = NULL;
							count++;
						}
					}
				}
			}
		}
		err = unzGoToNextFile(uf);
		if (err != UNZ_OK) {									// ̃Ggɐi߂ȂI
			break;
		}
		if (count >= gi.number_entry) break;
	}
	unzClose(uf);
	DList->count = count;

	return FData;
}


